"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.FixVersionParser = void 0;
const fix_versions_1 = require("../fix-versions");
class FixVersionParser {
    static getMajor(version) {
        switch (version) {
            case fix_versions_1.FixVersion.FIX50:
            case fix_versions_1.FixVersion.FIX50SP1:
            case fix_versions_1.FixVersion.FIX50SP2:
            case fix_versions_1.FixVersion.FIXML50SP2:
                return 5;
            case fix_versions_1.FixVersion.FIX40:
            case fix_versions_1.FixVersion.FIX41:
            case fix_versions_1.FixVersion.FIX42:
            case fix_versions_1.FixVersion.FIX43:
            case fix_versions_1.FixVersion.FIX44:
                return 4;
        }
        return 0;
    }
    static getMinor(version) {
        switch (version) {
            case fix_versions_1.FixVersion.FIX50:
            case fix_versions_1.FixVersion.FIX50SP1:
            case fix_versions_1.FixVersion.FIX50SP2:
            case fix_versions_1.FixVersion.FIXML50SP2:
                return 0;
            case fix_versions_1.FixVersion.FIX40:
                return 0;
            case fix_versions_1.FixVersion.FIX41:
                return 1;
            case fix_versions_1.FixVersion.FIX42:
                return 2;
            case fix_versions_1.FixVersion.FIX43:
                return 3;
            case fix_versions_1.FixVersion.FIX44:
                return 4;
        }
        return 0;
    }
    static getServicePack(version) {
        switch (version) {
            case fix_versions_1.FixVersion.FIX50SP1:
                return 1;
            case fix_versions_1.FixVersion.FIX50SP2:
            case fix_versions_1.FixVersion.FIXML50SP2:
                return 2;
        }
        return 0;
    }
}
exports.FixVersionParser = FixVersionParser;
//# sourceMappingURL=fix-version-parser.js.map