"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.StoreLoader = exports.ReplayResult = void 0;
const setup_1 = require("./setup");
const store_1 = require("../../store");
const types_1 = require("../../types");
class ReplayResult {
    constructor(views, store) {
        this.views = views;
        this.store = store;
        this.records = this.views.reduce((agg, v) => {
            if (v.getString(types_1.MsgTag.SenderCompID) === 'accept-comp') {
                agg.push(store_1.FixMsgStoreRecord.toMsgStoreRecord(v));
            }
            return agg;
        }, new Array());
    }
}
exports.ReplayResult = ReplayResult;
class StoreLoader {
    constructor(session) {
        this.session = session;
        this.setup = new setup_1.Setup(this.session, null);
    }
    init() {
        return __awaiter(this, void 0, void 0, function* () {
            yield this.setup.init();
        });
    }
    replay(fixLog) {
        return __awaiter(this, void 0, void 0, function* () {
            const views = yield this.setup.client.replayer.replayFixFile(fixLog);
            const store = new store_1.FixMsgMemoryStore('test', this.setup.clientConfig);
            const res = new ReplayResult(views, store);
            const toWrite = res.records.map((r) => __awaiter(this, void 0, void 0, function* () { return yield store.put(r); }));
            yield Promise.all(toWrite);
            return res;
        });
    }
}
exports.StoreLoader = StoreLoader;
//# sourceMappingURL=LogReplayer.js.map