/// <reference types="node" />
import { ISecAltIDGrp } from './sec_alt_id_grp';
import { IEvntGrp } from './evnt_grp';
import { IInstrumentParties } from './instrument_parties';
export interface IInstrument {
    Symbol?: string;
    SymbolSfx?: string;
    SecurityID?: string;
    SecurityIDSource?: string;
    SecAltIDGrp?: ISecAltIDGrp;
    Product?: number;
    SecurityGroup?: string;
    CFICode?: string;
    SecurityType?: string;
    SecuritySubType?: string;
    MaturityMonthYear?: string;
    MaturityDate?: Date;
    CouponPaymentDate?: Date;
    IssueDate?: Date;
    RepoCollateralSecurityType?: number;
    RepurchaseTerm?: number;
    RepurchaseRate?: number;
    Factor?: number;
    CreditRating?: string;
    InstrRegistry?: string;
    CountryOfIssue?: string;
    StateOrProvinceOfIssue?: string;
    LocaleOfIssue?: string;
    RedemptionDate?: Date;
    StrikePrice?: number;
    StrikeCurrency?: string;
    TickSize?: number;
    PriceLowLimit?: number;
    PriceHighLimit?: number;
    SizeLowLimit?: number;
    SizeHighLimit?: number;
    MaxAmount?: number;
    QuoteSizeLowLimit?: number;
    QuoteSizeHighLimit?: number;
    InstrumentPricePrecision?: number;
    InstrumentSizePrecision?: number;
    OptAttribute?: string;
    ContractMultiplier?: number;
    CouponRate?: number;
    SecurityExchange?: string;
    Issuer?: string;
    EncodedIssuerLen?: number;
    EncodedIssuer?: Buffer;
    SecurityDesc?: string;
    EncodedSecurityDescLen?: number;
    EncodedSecurityDesc?: Buffer;
    Pool?: string;
    ContractSettlMonth?: string;
    CPProgram?: number;
    CPRegType?: string;
    EvntGrp?: IEvntGrp;
    DatedDate?: Date;
    InterestAccrualDate?: Date;
    SecurityStatus?: string;
    SettleOnOpenFlag?: string;
    InstrmtAssignmentMethod?: string;
    StrikeMultiplier?: number;
    StrikeValue?: number;
    MinPriceIncrement?: number;
    PositionLimit?: number;
    NTPositionLimit?: number;
    InstrumentParties?: IInstrumentParties;
    UnitofMeasure?: string;
    TimeUnit?: string;
    MaturityTime?: string;
    RofexProps?: string;
    TradingDeadline?: number;
}
