/// <reference types="node" />
import { IStandardHeader } from './set/standard_header';
import { IInstrument } from './set/instrument';
import { ITrdRegTimestamps } from './set/trd_reg_timestamps';
import { ITrdInstrmtLegGrp } from './set/trd_instrmt_leg_grp';
import { IPositionAmountData } from './set/position_amount_data';
import { ITrdCapRptAckSideGrp } from './set/trd_cap_rpt_ack_side_grp';
import { IRootParties } from './set/root_parties';
import { IUndInstrmtGrp } from './set/und_instrmt_grp';
import { IStandardTrailer } from './set/standard_trailer';
export interface ITradeCaptureReportAck {
    StandardHeader: IStandardHeader;
    TradeReportID?: string;
    TradeReportTransType?: number;
    TradeReportType?: number;
    TrdType?: number;
    TrdSubType?: number;
    SecondaryTrdType?: number;
    TransferReason?: string;
    ExecType?: string;
    TradeReportRefID?: string;
    SecondaryTradeReportRefID?: string;
    TrdRptStatus?: number;
    TradeReportRejectReason?: number;
    SecondaryTradeReportID?: string;
    SubscriptionRequestType?: string;
    TradeLinkID?: string;
    TrdMatchID?: string;
    ExecID?: string;
    SecondaryExecID?: string;
    Instrument?: IInstrument;
    TransactTime?: Date;
    TrdRegTimestamps?: ITrdRegTimestamps;
    ResponseTransportType?: number;
    ResponseDestination?: string;
    Text?: string;
    EncodedTextLen?: number;
    EncodedText?: Buffer;
    TrdInstrmtLegGrp?: ITrdInstrmtLegGrp;
    ClearingFeeIndicator?: string;
    OrdStatus?: string;
    ExecRestatementReason?: number;
    PreviouslyReported?: boolean;
    PriceType?: number;
    UnderlyingTradingSessionID?: string;
    QtyType?: number;
    UnderlyingTradingSessionSubID?: string;
    LastQty?: number;
    LastPx?: number;
    LastParPx?: number;
    LastSpotRate?: number;
    LastForwardPoints?: number;
    LastMkt?: string;
    TradeDate?: Date;
    ClearingBusinessDate?: Date;
    AvgPx?: number;
    AvgPxIndicator?: number;
    MultiLegReportingType?: string;
    TradeLegRefID?: string;
    SettlType?: string;
    MatchStatus?: string;
    MatchType?: string;
    CopyMsgIndicator?: boolean;
    PublishTrdIndicator?: boolean;
    ShortSaleReason?: number;
    SettlDate?: Date;
    SettlSessID?: string;
    SettlSessSubID?: string;
    PositionAmountData?: IPositionAmountData;
    TierCode?: string;
    MessageEventSource?: string;
    LastUpdateTime?: Date;
    RndPx?: number;
    TrdCapRptAckSideGrp?: ITrdCapRptAckSideGrp;
    AsOfIndicator?: string;
    TradeID?: string;
    SecondaryTradeID?: string;
    FirmTradeID?: string;
    SecondaryFirmTradeID?: string;
    CalculatedCcyLastQty?: number;
    LastSwapPoints?: number;
    GrossTradeAmt?: number;
    RootParties?: IRootParties;
    TradeHandlingInstr?: string;
    OrigTradeHandlingInstr?: string;
    OrigTradeDate?: Date;
    OrigTradeID?: string;
    OrigSecondaryTradeID?: string;
    UndInstrmtGrp?: IUndInstrmtGrp;
    RptSys?: string;
    StandardTrailer: IStandardTrailer;
}
