import { IStandardHeader } from './set/standard_header'
import { IParties } from './set/parties'
import { IPositionQty } from './set/position_qty'
import { IInstrument } from './set/instrument'
import { IStandardTrailer } from './set/standard_trailer'

export interface IAdjustedPositionReport {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  PosMaintRptID: string// [2] 721 (String)
  PosReqType?: number// [3] 724 (Int)
  ClearingBusinessDate: Date// [4] 715 (LocalDate)
  SettlSessID?: string// [5] 716 (String)
  Parties?: IParties// [6] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  PositionQty?: IPositionQty// [7] NoPositions.702, PosType.703 .. QuantityDate.976
  Instrument?: IInstrument// [8] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  SettlPrice?: number// [9] 730 (Float)
  PriorSettlPrice?: number// [10] 734 (Float)
  PosMaintRptRefID?: string// [11] 714 (String)
  StandardTrailer: IStandardTrailer// [12] SignatureLength.93, Signature.89, CheckSum.10
}
