import { IStandardHeader } from './set/standard_header'
import { IParties } from './set/parties'
import { IExpirationQty } from './set/expiration_qty'
import { IInstrument } from './set/instrument'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface IContraryIntentionReport {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  ContIntRptID: string// [2] 977 (String)
  TransactTime?: Date// [3] 60 (UtcTimestamp)
  LateIndicator?: boolean// [4] 978 (Boolean)
  InputSource?: string// [5] 979 (String)
  ClearingBusinessDate: Date// [6] 715 (LocalDate)
  Parties?: IParties// [7] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  ExpirationQty?: IExpirationQty// [8] NoExpiration.981, ExpType.982, ExpQty.983
  Instrument?: IInstrument// [9] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  Text?: string// [10] 58 (String)
  EncodedTextLen?: number// [11] 354 (Length)
  EncodedText?: Buffer// [12] 355 (RawData)
  UndInstrmtGrp?: IUndInstrmtGrp// [13] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  StandardTrailer: IStandardTrailer// [14] SignatureLength.93, Signature.89, CheckSum.10
}
