import { IStandardHeader } from './set/standard_header'
import { ISideCrossOrdCxlGrp } from './set/side_cross_ord_cxl_grp'
import { IInstrument } from './set/instrument'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { IInstrmtLegGrp } from './set/instrmt_leg_grp'
import { IRootParties } from './set/root_parties'
import { IStandardTrailer } from './set/standard_trailer'

export interface ICrossOrderCancelRequest {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  OrderID?: string// [2] 37 (String)
  CrossID: string// [3] 548 (String)
  OrigCrossID: string// [4] 551 (String)
  CrossType: number// [5] 549 (Int)
  CrossPrioritization: number// [6] 550 (Int)
  SideCrossOrdCxlGrp?: ISideCrossOrdCxlGrp// [7] NoSides.552, Side.54 .. EncodedText.355
  Instrument?: IInstrument// [8] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  UndInstrmtGrp?: IUndInstrmtGrp// [9] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  InstrmtLegGrp?: IInstrmtLegGrp// [10] NoLegs.555, LegSymbol.600 .. LegTimeUnit.1001
  TransactTime: Date// [11] 60 (UtcTimestamp)
  HostCrossID?: string// [12] 961 (String)
  RootParties?: IRootParties// [13] NoRootPartyIDs.1116, RootPartyID.1117 .. RootPartySubIDType.1122
  StandardTrailer: IStandardTrailer// [14] SignatureLength.93, Signature.89, CheckSum.10
}
