export enum AdvSide {
  Buy = 'B',
  Sell = 'S',
  Cross = 'X',
  Trade = 'T'
}

export enum AdvTransType {
  New = 'N',
  Cancel = 'C',
  Replace = 'R'
}

export enum CommType {
  PerUnit = '1',
  Percentage = '2',
  Absolute = '3',
  PercentageWaivedCashDiscount = '4',
  PercentageWaivedEnhancedUnits = '5',
  PointsPerBondOrOrContract = '6'
}

export enum ExecInst {
  StayOnOfferside = '0',
  NotHeld = '1',
  Work = '2',
  GoAlong = '3',
  OverTheDay = '4',
  Held = '5',
  ParticipateDontInitiate = '6',
  StrictScale = '7',
  TryToScale = '8',
  StayOnBidside = '9',
  NoCross = 'A',
  OkToCross = 'B',
  CallFirst = 'C',
  PercentOfVolume = 'D',
  DoNotIncrease = 'E',
  DoNotReduce = 'F',
  AllOrNone = 'G',
  ReinstateOnSystemFailure = 'H',
  InstitutionsOnly = 'I',
  ReinstateOnTradingHalt = 'J',
  CancelOnTradingHalt = 'K',
  LastPeg = 'L',
  MidPrice = 'M',
  NonNegotiable = 'N',
  OpeningPeg = 'O',
  MarketPeg = 'P',
  CancelOnSystemFailure = 'Q',
  PrimaryPeg = 'R',
  Suspend = 'S',
  FixedPegToLocalBestBidOrOfferAtTimeOfOrder = 'T',
  CustomerDisplayInstruction = 'U',
  Netting = 'V',
  PegToVwap = 'W',
  TradeAlong = 'X',
  TryToStop = 'Y',
  CancelIfNotBest = 'Z',
  TrailingStopPeg = 'a',
  StrictLimit = 'b',
  IgnorePriceValidityChecks = 'c',
  PegToLimitPrice = 'd',
  WorkToTargetStrategy = 'e',
  IntermarketSweep = 'f',
  ExternalRoutingAllowed = 'g',
  ExternalRoutingNotAllowed = 'h',
  ImbalanceOnly = 'i',
  SingleExecutionRequestedForBlockTrade = 'j',
  BestExecution = 'k',
  RofexOrderHandler = 'x',
  CancelOnConnectionLoss = 'o'
}

export enum ExecTransType {
  New = '0',
  Cancel = '1',
  Correct = '2',
  Status = '3'
}

export enum HandlInst {
  AutomatedExecutionOrderPrivate = '1',
  AutomatedExecutionOrderPublic = '2',
  ManualOrder = '3'
}

export enum SecurityIDSource {
  Cusip = '1',
  Sedol = '2',
  Quik = '3',
  IsinNumber = '4',
  RicCode = '5',
  IsoCurrencyCode = '6',
  IsoCountryCode = '7',
  ExchangeSymbol = '8',
  ConsolidatedTapeAssociation = '9',
  BloombergSymbol = 'A',
  Wertpapier = 'B',
  Dutch = 'C',
  Valoren = 'D',
  Sicovam = 'E',
  Belgian = 'F',
  Common = 'G',
  ClearingHouseClearingOrganization = 'H',
  IsdaFpmlProductSpecification = 'I',
  OptionsPriceReportingAuthority = 'J',
  IsdaFpmlProductUrl = 'K',
  LetterOfCredit = 'L',
  MarketPlaceAssignedIdentifier = 'M'
}

export enum IOIQltyInd {
  Low = 'L',
  Medium = 'M',
  High = 'H'
}

export enum IOIQty {
  E1000000000 = '0',
  Small = 'S',
  Medium = 'M',
  Large = 'L',
  UndisclosedQuantity = 'U'
}

export enum IOITransType {
  New = 'N',
  Cancel = 'C',
  Replace = 'R'
}

export enum LastCapacity {
  Agent = '1',
  CrossAsAgent = '2',
  CrossAsPrincipal = '3',
  Principal = '4'
}

export enum MsgType {
  Heartbeat = '0',
  TestRequest = '1',
  ResendRequest = '2',
  Reject = '3',
  SequenceReset = '4',
  Logout = '5',
  IndicationOfInterest = '6',
  Advertisement = '7',
  ExecutionReport = '8',
  OrderCancelReject = '9',
  Logon = 'A',
  News = 'B',
  Email = 'C',
  OrderSingle = 'D',
  OrderList = 'E',
  OrderCancelRequest = 'F',
  OrderCancelReplaceRequest = 'G',
  OrderStatusRequest = 'H',
  AllocationInstruction = 'J',
  ListCancelRequest = 'K',
  ListExecute = 'L',
  ListStatusRequest = 'M',
  ListStatus = 'N',
  AllocationInstructionAck = 'P',
  DontKnowTrade = 'Q',
  QuoteRequest = 'R',
  Quote = 'S',
  SettlementInstructions = 'T',
  MarketDataRequest = 'V',
  MarketDataSnapshotFullRefresh = 'W',
  MarketDataIncrementalRefresh = 'X',
  MarketDataRequestReject = 'Y',
  QuoteCancel = 'Z',
  QuoteStatusRequest = 'a',
  MassQuoteAcknowledgement = 'b',
  SecurityDefinitionRequest = 'c',
  SecurityDefinition = 'd',
  SecurityStatusRequest = 'e',
  SecurityStatus = 'f',
  TradingSessionStatusRequest = 'g',
  TradingSessionStatus = 'h',
  MassQuote = 'i',
  BusinessMessageReject = 'j',
  BidRequest = 'k',
  BidResponse = 'l',
  ListStrikePrice = 'm',
  XmlMessage = 'n',
  RegistrationInstructions = 'o',
  RegistrationInstructionsResponse = 'p',
  OrderMassCancelRequest = 'q',
  OrderMassCancelReport = 'r',
  NewOrderCross = 's',
  CrossOrderCancelReplaceRequest = 't',
  CrossOrderCancelRequest = 'u',
  SecurityTypeRequest = 'v',
  SecurityTypes = 'w',
  SecurityListRequest = 'x',
  SecurityList = 'y',
  DerivativeSecurityListRequest = 'z',
  DerivativeSecurityList = 'AA',
  NewOrderMultileg = 'AB',
  MultilegOrderCancelReplace = 'AC',
  TradeCaptureReportRequest = 'AD',
  TradeCaptureReport = 'AE',
  OrderMassStatusRequest = 'AF',
  QuoteRequestReject = 'AG',
  RfqRequest = 'AH',
  QuoteStatusReport = 'AI',
  QuoteResponse = 'AJ',
  Confirmation = 'AK',
  PositionMaintenanceRequest = 'AL',
  PositionMaintenanceReport = 'AM',
  RequestForPositions = 'AN',
  RequestForPositionsAck = 'AO',
  PositionReport = 'AP',
  TradeCaptureReportRequestAck = 'AQ',
  TradeCaptureReportAck = 'AR',
  AllocationReport = 'AS',
  AllocationReportAck = 'AT',
  ConfirmationAck = 'AU',
  SettlementInstructionRequest = 'AV',
  AssignmentReport = 'AW',
  CollateralRequest = 'AX',
  CollateralAssignment = 'AY',
  CollateralResponse = 'AZ',
  CollateralReport = 'BA',
  CollateralInquiry = 'BB',
  NetworkStatusRequest = 'BC',
  NetworkStatusResponse = 'BD',
  UserRequest = 'BE',
  UserResponse = 'BF',
  CollateralInquiryAck = 'BG',
  ConfirmationRequest = 'BH',
  TradingSessionListRequest = 'BI',
  TradingSessionList = 'BJ',
  SecurityListUpdateReport = 'BK',
  AdjustedPositionReport = 'BL',
  AllocationInstructionAlert = 'BM',
  ExecutionAcknowledgement = 'BN',
  ContraryIntentionReport = 'BO',
  SecurityDefinitionUpdateReport = 'BP',
  AccountListRequest = 'UALR',
  AccountList = 'UALT',
  AccountListIncremental = 'UALI'
}

export enum OrdStatus {
  New = '0',
  PartiallyFilled = '1',
  Filled = '2',
  DoneForDay = '3',
  Canceled = '4',
  Replaced = '5',
  PendingCancel = '6',
  Stopped = '7',
  Rejected = '8',
  Suspended = '9',
  PendingNew = 'A',
  Calculated = 'B',
  Expired = 'C',
  AcceptedForBidding = 'D',
  PendingReplace = 'E',
  PendingApproval = 'F'
}

export enum OrdType {
  Market = '1',
  Limit = '2',
  Stop = '3',
  StopLimit = '4',
  MarketOnClose = '5',
  WithOrWithout = '6',
  LimitOrBetter = '7',
  LimitWithOrWithout = '8',
  OnBasis = '9',
  OnClose = 'A',
  LimitOnClose = 'B',
  ForexMarket = 'C',
  PreviouslyQuoted = 'D',
  PreviouslyIndicated = 'E',
  ForexLimit = 'F',
  ForexSwap = 'G',
  ForexPreviouslyQuoted = 'H',
  Funari = 'I',
  MarketIfTouched = 'J',
  MarketWithLeftoverAsLimit = 'K',
  PreviousFundValuationPoint = 'L',
  NextFundValuationPoint = 'M',
  Pegged = 'P',
  CounterOrderSelection = 'Q',
  StopLimitMerval = 'z'
}

export enum Side {
  Buy = '1',
  Sell = '2',
  BuyMinus = '3',
  SellPlus = '4',
  SellShort = '5',
  SellShortExempt = '6',
  Undisclosed = '7',
  Cross = '8',
  CrossShort = '9',
  CrossShortExempt = 'A',
  AsDefined = 'B',
  Opposite = 'C',
  Subscribe = 'D',
  Redeem = 'E',
  Lend = 'F',
  Borrow = 'G'
}

export enum TimeInForce {
  Day = '0',
  GoodTillCancel = '1',
  AtTheOpening = '2',
  ImmediateOrCancel = '3',
  FillOrKill = '4',
  GoodTillCrossing = '5',
  GoodTillDate = '6',
  AtTheClose = '7'
}

export enum Urgency {
  Normal = '0',
  Flash = '1',
  Background = '2'
}

export enum SettlType {
  Regular = '0',
  Cash = '1',
  NextDay = '2',
  TPlus2 = '3',
  TPlus3 = '4',
  TPlus4 = '5',
  Future = '6',
  WhenAndIfIssued = '7',
  SellersOption = '8',
  TPlus5 = '9',
  FxSpotNextSettlement = 'C',
  BrokenDate = 'B'
}

export enum SymbolSfx {
  WhenIssued = 'WI',
  AEucpWithLumpSumInterest = 'CD'
}

export enum AllocTransType {
  New = '0',
  Replace = '1',
  Cancel = '2',
  Preliminary = '3',
  Calculated = '4',
  CalculatedWithoutPreliminary = '5',
  Reversal = '6'
}

export enum PositionEffect {
  Open = 'O',
  Close = 'C',
  Rolled = 'R',
  Fifo = 'F'
}

export enum ProcessCode {
  Regular = '0',
  SoftDollar = '1',
  StepIn = '2',
  StepOut = '3',
  SoftDollarStepIn = '4',
  SoftDollarStepOut = '5',
  PlanSponsor = '6'
}

export enum AllocStatus {
  Accepted = 0,
  BlockLevelReject = 1,
  AccountLevelReject = 2,
  Received = 3,
  Incomplete = 4,
  RejectedByIntermediary = 5,
  AllocationPending = 6,
  Reversed = 7
}

export enum AllocRejCode {
  UnknownAccount = 0,
  IncorrectQuantity = 1,
  IncorrectAveragePrice = 2,
  UnknownExecutingBrokerMnemonic = 3,
  CommissionDifference = 4,
  UnknownOrderid = 5,
  UnknownListid = 6,
  Other = 7,
  IncorrectAllocatedQuantity = 8,
  CalculationDifference = 9,
  UnknownOrStaleExecId = 10,
  MismatchedDataValue = 11,
  UnknownClordid = 12,
  WarehouseRequestRejected = 13
}

export enum EmailType {
  New = '0',
  Reply = '1',
  AdminReply = '2'
}

export enum EncryptMethod {
  NoneOther = 0,
  Pkcs = 1,
  Des = 2,
  PkcsDes = 3,
  PgpDes = 4,
  PgpDesMd5 = 5,
  PemDesMd5 = 6
}

export enum CxlRejReason {
  TooLateToCancel = 0,
  UnknownOrder = 1,
  BrokerExchangeOption = 2,
  OrderAlreadyInPendingCancelOrPendingReplaceStatus = 3,
  UnableToProcessOrderMassCancelRequest = 4,
  OrigordmodtimeDidNotMatchLastTransacttimeOfOrder = 5,
  DuplicateClordidReceived = 6,
  InvalidPriceIncrement = 18,
  Other = 99
}

export enum OrdRejReason {
  BrokerExchangeOption = 0,
  UnknownSymbol = 1,
  ExchangeClosed = 2,
  OrderExceedsLimit = 3,
  TooLateToEnter = 4,
  UnknownOrder = 5,
  DuplicateOrder = 6,
  DuplicateOfAVerballyCommunicatedOrder = 7,
  StaleOrder = 8,
  TradeAlongRequired = 9,
  InvalidInvestorId = 10,
  UnsupportedOrderCharacteristic = 11,
  SurveillenceOption = 12,
  IncorrectQuantity = 13,
  IncorrectAllocatedQuantity = 14,
  UnknownAccount = 15,
  InvalidPriceIncrement = 18,
  Other = 99
}

export enum IOIQualifier {
  AllOrNone = 'A',
  MarketOnClose = 'B',
  AtTheClose = 'C',
  Vwap = 'D',
  InTouchWith = 'I',
  Limit = 'L',
  MoreBehind = 'M',
  AtTheOpen = 'O',
  TakingAPosition = 'P',
  AtTheMarket = 'Q',
  ReadyToTrade = 'R',
  PortfolioShown = 'S',
  ThroughTheDay = 'T',
  Versus = 'V',
  IndicationWorkingAway = 'W',
  CrossingOpportunity = 'X',
  AtTheMidpoint = 'Y',
  PreOpen = 'Z'
}

export enum CxlType {
  PartialCancel = 'P',
  FullRemainingQuantity = 'F'
}

export enum DKReason {
  UnknownSymbol = 'A',
  WrongSide = 'B',
  QuantityExceedsOrder = 'C',
  NoMatchingOrder = 'D',
  PriceExceedsLimit = 'E',
  CalculationDifference = 'F',
  Other = 'Z'
}

export enum MiscFeeType {
  Regulatory = '1',
  Tax = '2',
  LocalCommission = '3',
  ExchangeFees = '4',
  Stamp = '5',
  Levy = '6',
  Other = '7',
  Markup = '8',
  ConsumptionTax = '9',
  PerTransaction = '10',
  Conversion = '11',
  Agent = '12',
  TransferFee = '13',
  SecurityLending = '14'
}

export enum ExecType {
  New = '0',
  PartialFill = '1',
  Fill = '2',
  DoneForDay = '3',
  Canceled = '4',
  Replace = '5',
  PendingCancel = '6',
  Stopped = '7',
  Rejected = '8',
  Suspended = '9',
  PendingNew = 'A',
  Calculated = 'B',
  Expired = 'C',
  Restated = 'D',
  PendingReplace = 'E',
  Trade = 'F',
  TradeCorrect = 'G',
  TradeCancel = 'H',
  OrderStatus = 'I',
  TradeInAClearingHold = 'J',
  TradeHasBeenReleasedToClearing = 'K',
  TriggeredOrActivatedBySystem = 'L'
}

export enum SettlCurrFxRateCalc {
  Multiply = 'M',
  Divide = 'D'
}

export enum SettlInstMode {
  Default = '0',
  StandingInstructionsProvided = '1',
  SpecificAllocationAccountOverriding = '2',
  SpecificAllocationAccountStanding = '3',
  SpecificOrderForASingleAccount = '4',
  RequestReject = '5'
}

export enum SettlInstTransType {
  New = 'N',
  Cancel = 'C',
  Replace = 'R',
  Restate = 'T'
}

export enum SettlInstSource {
  BrokersInstructions = '1',
  InstitutionsInstructions = '2',
  Investor = '3'
}

export enum SettlLocation {
  Cedel = 'CED',
  DepositoryTrustCompany = 'DTC',
  Euroclear = 'EUR',
  FederalBookEntry = 'FED',
  LocalMarketSettleLocation = 'ISO',
  Physical = 'PNY',
  ParticipantTrustCompany = 'PTC'
}

export enum SecurityType {
  Wildcard = '?',
  AssetBackedSecurities = 'ABS',
  AmendedAndRestated = 'AMENDED',
  OtherAnticipationNotes = 'AN',
  BankersAcceptance = 'BA',
  BankNotes = 'BN',
  BillOfExchanges = 'BOX',
  BradyBond = 'BRADY',
  BridgeLoan = 'BRIDGE',
  BuySellback = 'BUYSELL',
  ConvertibleBond = 'CB',
  CertificateOfDeposit = 'CD',
  CallLoans = 'CL',
  CorpMortgageBackedSecurities = 'CMBS',
  CollateralizedMortgageObligation = 'CMO',
  CertificateOfObligation = 'COFO',
  CertificateOfParticipation = 'COFP',
  CorporateBond = 'CORP',
  CommercialPaper = 'CP',
  CorporatePrivatePlacement = 'CPP',
  CommonStock = 'CS',
  Defaulted = 'DEFLTED',
  DebtorInPossession = 'DINP',
  DepositNotes = 'DN',
  DualCurrency = 'DUAL',
  EuroCertificateOfDeposit = 'EUCD',
  EuroCorporateBond = 'EUCORP',
  EuroCommercialPaper = 'EUCP',
  EuroSovereigns = 'EUSOV',
  EuroSupranationalCoupons = 'EUSUPRA',
  FederalAgencyCoupon = 'FAC',
  FederalAgencyDiscountNote = 'FADN',
  ForeignExchangeContract = 'FOR',
  Forward = 'FORWARD',
  Future = 'FUT',
  GeneralObligationBonds = 'GO',
  IoetteMortgage = 'IET',
  LetterOfCredit = 'LOFC',
  LiquidityNote = 'LQN',
  Matured = 'MATURED',
  MortgageBackedSecurities = 'MBS',
  MutualFund = 'MF',
  MortgageInterestOnly = 'MIO',
  MultiLegInstrument = 'MLEG',
  MortgagePrincipalOnly = 'MPO',
  MortgagePrivatePlacement = 'MPP',
  MiscellaneousPassThrough = 'MPT',
  MandatoryTender = 'MT',
  MediumTermNotes = 'MTN',
  NoSecurityType = 'NONE',
  Overnight = 'ONITE',
  Option = 'OPT',
  PrivateExportFunding = 'PEF',
  Pfandbriefe = 'PFAND',
  PromissoryNote = 'PN',
  PreferredStock = 'PS',
  PlazosFijos = 'PZFJ',
  RevenueAnticipationNote = 'RAN',
  Replaced = 'REPLACD',
  Repurchase = 'REPO',
  Retired = 'RETIRED',
  RevenueBonds = 'REV',
  RevolverLoan = 'RVLV',
  RevolverTermLoan = 'RVLVTRM',
  SecuritiesLoan = 'SECLOAN',
  SecuritiesPledge = 'SECPLEDGE',
  SpecialAssessment = 'SPCLA',
  SpecialObligation = 'SPCLO',
  SpecialTax = 'SPCLT',
  ShortTermLoanNote = 'STN',
  StructuredNotes = 'STRUCT',
  UsdSupranationalCoupons = 'SUPRA',
  SwingLineFacility = 'SWING',
  TaxAnticipationNote = 'TAN',
  TaxAllocation = 'TAXA',
  ToBeAnnounced = 'TBA',
  UsTreasuryBill = 'TBILL',
  UsTreasuryBond = 'TBOND',
  PrincipalStripOfACallableBondOrNote = 'TCAL',
  TimeDeposit = 'TD',
  TaxExemptCommercialPaper = 'TECP',
  TermLoan = 'TERM',
  InterestStripFromAnyBondOrNote = 'TINT',
  TreasuryInflationProtectedSecurities = 'TIPS',
  UsTreasuryNote = 'TNOTE',
  PrincipalStripFromANonCallableBondOrNote = 'TPRN',
  TaxAndRevenueAnticipationNote = 'TRAN',
  UsTreasuryNote2 = 'UST',
  UsTreasuryBill2 = 'USTB',
  VariableRateDemandNote = 'VRDN',
  Warrant = 'WAR',
  Withdrawn = 'WITHDRN',
  Unknown = 'WLD',
  ExtendedCommNote = 'XCN',
  IndexedLinked = 'XLINKD',
  YankeeCorporateBond = 'YANK',
  YankeeCertificateOfDeposit = 'YCD',
  OptionsOnPhysical = 'OOP',
  OptionsOnFutures = 'OOF',
  Cash = 'CASH',
  QualifyingShares = 'QS'
}

export enum StandInstDbType {
  Other = 0,
  DtcSid = 1,
  ThomsonAlert = 2,
  AGlobalCustodian = 3,
  Accountnet = 4
}

export enum SettlDeliveryType {
  VersusPayment = 0,
  Free = 1,
  TriParty = 2,
  HoldInCustody = 3
}

export enum AllocLinkType {
  FXNetting = 0,
  FXSwap = 1
}

export enum PutOrCall {
  Put = 0,
  Call = 1
}

export enum CoveredOrUncovered {
  Covered = 0,
  Uncovered = 1
}

export enum CustomerOrFirm {
  Customer = 0,
  Firm = 1
}

export enum AllocHandlInst {
  Match = 1,
  Forward = 2,
  ForwardAndMatch = 3
}

export enum RoutingType {
  TargetFirm = 1,
  TargetList = 2,
  BlockFirm = 3,
  BlockList = 4
}

export enum Benchmark {
  Curve = '1',
  Fiveyr = '2',
  Old5 = '3',
  Tenyr = '4',
  Old10 = '5',
  Thirtyyr = '6',
  Old30 = '7',
  Threemolibor = '8',
  Sixmolibor = '9'
}

export enum BenchmarkCurveName {
  Eonia = 'EONIA',
  Eurepo = 'EUREPO',
  Euribor = 'Euribor',
  Futureswap = 'FutureSWAP',
  Libid = 'LIBID',
  Libor = 'LIBOR',
  Muniaaa = 'MuniAAA',
  Other = 'OTHER',
  Pfandbriefe = 'Pfandbriefe',
  Sonia = 'SONIA',
  Swap = 'SWAP',
  Treasury = 'Treasury'
}

export enum StipulationType {
  AbsolutePrepaymentSpeed = 'ABS',
  Amt = 'AMT',
  AutoReinvestmentAtOrBetter = 'AUTOREINV',
  BankQualified = 'BANKQUAL',
  BargainConditions = 'BGNCON',
  CouponRange = 'COUPON',
  ConstantPrepaymentPenalty = 'CPP',
  ConstantPrepaymentRate = 'CPR',
  ConstantPrepaymentYield = 'CPY',
  IsoCurrencyCode = 'CURRENCY',
  CustomStartEndDate = 'CUSTOMDATE',
  GeographicsAndPercentRange = 'GEOG',
  ValuationDiscount = 'HAIRCUT',
  FinalCprOfHomeEquityPrepaymentCurve = 'HEP',
  Insured = 'INSURED',
  YearOrYearMonthOfIssue = 'ISSUE',
  IssuersTicker = 'ISSUER',
  IssueSizeRange = 'ISSUESIZE',
  LookbackDays = 'LOOKBACK',
  ExplicitLotIdentifier = 'LOT',
  LotVariance = 'LOTVAR',
  MaturityYearAndMonth = 'MAT',
  MaturityRange = 'MATURITY',
  MaximumSubstitutions = 'MAXSUBS',
  PercentOfManufacturedHousingPrepaymentCurve = 'MHP',
  MinimumDenomination = 'MINDNOM',
  MinimumIncrement = 'MININCR',
  MinimumQuantity = 'MINQTY',
  MonthlyPrepaymentRate = 'MPR',
  PaymentFrequencyCalendar = 'PAYFREQ',
  NumberOfPieces = 'PIECES',
  PoolsMaximum = 'PMAX',
  PercentOfProspectusPrepaymentCurve = 'PPC',
  PoolsPerLot = 'PPL',
  PoolsPerMillion = 'PPM',
  PoolsPerTrade = 'PPT',
  PriceRange = 'PRICE',
  PricingFrequency = 'PRICEFREQ',
  ProductionYear = 'PROD',
  CallProtection = 'PROTECT',
  PercentOfBmaPrepaymentCurve = 'PSA',
  Purpose = 'PURPOSE',
  BenchmarkPriceSource = 'PXSOURCE',
  RatingSourceAndRange = 'RATING',
  TypeOfRedemption = 'REDEMPTION',
  Restricted = 'RESTRICTED',
  MarketSector = 'SECTOR',
  SecuritytypeIncludedOrExcluded = 'SECTYPE',
  SingleMonthlyMortality = 'SMM',
  Structure = 'STRUCT',
  SubstitutionsFrequency = 'SUBSFREQ',
  SubstitutionsLeft = 'SUBSLEFT',
  FreeformText = 'TEXT',
  TradeVariance = 'TRDVAR',
  WeightedAverageCoupon = 'WAC',
  WeightedAverageLifeCoupon = 'WAL',
  WeightedAverageLoanAge = 'WALA',
  WeightedAverageMaturity = 'WAM',
  WholePool = 'WHOLE',
  YieldRange = 'YIELD'
}

export enum StipulationValue {
  SpecialCumDividend = 'CD',
  SpecialExDividend = 'XD',
  SpecialCumCoupon = 'CC',
  SpecialExCoupon = 'XC',
  SpecialCumBonus = 'CB',
  SpecialExBonus = 'XB',
  SpecialCumRights = 'CR',
  SpecialExRights = 'XR',
  SpecialCumCapitalRepayments = 'CP',
  SpecialExCapitalRepayments = 'XP',
  CashSettlement = 'CS',
  SpecialPrice = 'SP',
  ReportForEuropeanEquityMarketSecurities = 'TR',
  GuaranteedDelivery = 'GD'
}

export enum YieldType {
  AfterTaxYield = 'AFTERTAX',
  AnnualYield = 'ANNUAL',
  YieldAtIssue = 'ATISSUE',
  YieldToAverageMaturity = 'AVGMATURITY',
  BookYield = 'BOOK',
  YieldToNextCall = 'CALL',
  YieldChangeSinceClose = 'CHANGE',
  ClosingYield = 'CLOSE',
  CompoundYield = 'COMPOUND',
  CurrentYield = 'CURRENT',
  GovernmentEquivalentYield = 'GOVTEQUIV',
  TrueGrossYield = 'GROSS',
  YieldWithInflationAssumption = 'INFLATION',
  InverseFloaterBondYield = 'INVERSEFLOATER',
  MostRecentClosingYield = 'LASTCLOSE',
  ClosingYieldMostRecentMonth = 'LASTMONTH',
  ClosingYieldMostRecentQuarter = 'LASTQUARTER',
  ClosingYieldMostRecentYear = 'LASTYEAR',
  YieldToLongestAverageLife = 'LONGAVGLIFE',
  MarkToMarketYield = 'MARK',
  YieldToMaturity = 'MATURITY',
  YieldToNextRefund = 'NEXTREFUND',
  OpenAverageYield = 'OPENAVG',
  PreviousCloseYield = 'PREVCLOSE',
  ProceedsYield = 'PROCEEDS',
  YieldToNextPut = 'PUT',
  SemiAnnualYield = 'SEMIANNUAL',
  YieldToShortestAverageLife = 'SHORTAVGLIFE',
  SimpleYield = 'SIMPLE',
  TaxEquivalentYield = 'TAXEQUIV',
  YieldToTenderDate = 'TENDER',
  TrueYield = 'TRUE',
  YieldValueOf132 = 'VALUE1_32',
  YieldToWorst = 'WORST'
}

export enum SubscriptionRequestType {
  Snapshot = '0',
  SnapshotPlusUpdates = '1',
  DisablePreviousSnapshotPlusUpdateRequest = '2'
}

export enum MDUpdateType {
  FullRefresh = 0,
  IncrementalRefresh = 1
}

export enum MDEntryType {
  Bid = '0',
  Offer = '1',
  Trade = '2',
  IndexValue = '3',
  OpeningPrice = '4',
  ClosingPrice = '5',
  SettlementPrice = '6',
  TradingSessionHighPrice = '7',
  TradingSessionLowPrice = '8',
  TradingSessionVwapPrice = '9',
  Imbalance = 'A',
  TradeVolume = 'B',
  OpenInterest = 'C',
  CompositeUnderlyingPrice = 'D',
  SimulatedSellPrice = 'E',
  SimulatedBuyPrice = 'F',
  MarginRate = 'G',
  MidPrice = 'H',
  EmptyBook = 'J',
  SettleHighPrice = 'K',
  SettleLowPrice = 'L',
  PriorSettlePrice = 'M',
  SessionHighBid = 'N',
  SessionLowOffer = 'O',
  EarlyPrices = 'P',
  AuctionClearingPrice = 'Q',
  TradeCount = 'v',
  TradeEffectiveVolume = 'w',
  TradeNominalVolume = 'x',
  OpenInterestDate = 'y',
  SettlementDate = 'z',
  FixingPrice = 'W'
}

export enum TickDirection {
  PlusTick = '0',
  ZeroPlusTick = '1',
  MinusTick = '2',
  ZeroMinusTick = '3'
}

export enum QuoteCondition {
  ReservedSam = '0',
  NoActiveSam = '1',
  Restricted = '2',
  NoMarketActivity = '1000',
  NoDataAvailable = '1001',
  NotApplicable = '1002',
  AmountThresholdExceeded = '1003',
  OpenActive = 'A',
  ClosedInactive = 'B',
  ExchangeBest = 'C',
  ConsolidatedBest = 'D',
  Locked = 'E',
  Crossed = 'F',
  Depth = 'G',
  FastTrading = 'H',
  NonFirm = 'I',
  ManualSlowQuote = 'L',
  OutrightPrice = 'J',
  ImpliedPrice = 'K',
  DepthOnOffer = 'M',
  DepthOnBid = 'N',
  Closing = 'O',
  NewsDissemination = 'P',
  TradingRange = 'Q',
  OrderInflux = 'R',
  DueToRelated = 'S',
  NewsPending = 'T',
  AdditionalInfo = 'U',
  AdditionalInfoDueToRelated = 'V',
  Resume = 'W',
  ViewOfCommon = 'X',
  VolumeAlert = 'Y',
  OrderImbalance = 'Z',
  EquipmentChangeover = 'a',
  NoOpen = 'b',
  RegularEth = 'c',
  AutomaticExecution = 'd',
  AutomaticExecutionEth = 'e',
  FastMarketEth = 'f',
  InactiveEth = 'g',
  Rotation = 'h',
  RotationEth = 'i',
  Halt = 'j',
  HaltEth = 'k',
  DueToNewsDissemination = 'l',
  DueToNewsPending = 'm',
  TradingResume = 'n',
  OutOfSequence = 'o',
  BidSpecialist = 'p',
  OfferSpecialist = 'q',
  BidOfferSpecialist = 'r',
  EndOfDaySam = 's',
  ForbiddenSam = 't',
  FrozenSam = 'u',
  PreopeningSam = 'v',
  OpeningSam = 'w',
  OpenSam = 'x',
  SurveillanceSam = 'y',
  SuspendedSam = 'z'
}

export enum TradeCondition {
  Cancel = '0',
  NoMarketActivity = '1000',
  NoDataAvailable = '1001',
  NotApplicable = '1002',
  CashMarket = 'A',
  AveragePriceTrade = 'B',
  CashTrade = 'C',
  NextDayMarket = 'D',
  OpeningReopeningTradeDetail = 'E',
  IntradayTradeDetail = 'F',
  Rule127 = 'G',
  Rule155 = 'H',
  SoldLast = 'I',
  NextDayTrade = 'J',
  Opened = 'K',
  Seller = 'L',
  Sold = 'M',
  StoppedStock = 'N',
  ImbalanceMoreBuyers = 'P',
  ImbalanceMoreSellers = 'Q',
  OpeningPrice = 'R',
  TradesResultingFromManualSlowQuote = 'Y',
  TradesResultingFromIntermarketSweep = 'Z',
  BargainCondition = 'S',
  ConvertedPriceIndicator = 'T',
  ExchangeLast = 'U',
  FinalPriceOfSession = 'V',
  ExPit = 'W',
  Crossed = 'X',
  VolumeOnly = 'a',
  DirectPlus = 'b',
  Acquisition = 'c',
  Bunched = 'd',
  Distribution = 'e',
  BunchedSale = 'f',
  SplitTrade = 'g',
  CancelStopped = 'h',
  CancelEth = 'i',
  CancelStoppedEth = 'j',
  OutOfSequenceEth = 'k',
  CancelLastEth = 'l',
  SoldLastSaleEth = 'm',
  CancelLast = 'n',
  SoldLastSale = 'o',
  CancelOpen = 'p',
  CancelOpenEth = 'q',
  OpenedSaleEth = 'r',
  CancelOnly = 's',
  CancelOnlyEth = 't',
  LateOpenEth = 'u',
  AutoExecutionEth = 'v',
  Reopen = 'w',
  ReopenEth = 'x',
  Adjusted = 'y',
  AdjustedEth = 'z',
  Spread = 'AA',
  SpreadEth = 'AB',
  Straddle = 'AC',
  StraddleEth = 'AD',
  Stopped = 'AE',
  StoppedEth = 'AF',
  RegularEth = 'AG',
  Combo = 'AH',
  ComboEth = 'AI',
  OfficialClosingPrice = 'AJ',
  PriorReferencePrice = 'AK',
  StoppedSoldLast = 'AL',
  StoppedOutOfSequence = 'AM',
  OfficalClosingPrice = 'AN',
  Crossed2 = 'AO',
  FastMarket = 'AP',
  AutomaticExecution = 'AQ',
  FormT = 'AR',
  BasketIndex = 'AS',
  BurstBasket = 'AT'
}

export enum MDUpdateAction {
  New = '0',
  Change = '1',
  Delete = '2',
  DeleteThru = '3',
  DeleteFrom = '4',
  Overlay = '5'
}

export enum MDReqRejReason {
  UnknownSymbol = '0',
  DuplicateMdreqid = '1',
  InsufficientBandwidth = '2',
  InsufficientPermissions = '3',
  UnsupportedSubscriptionrequesttype = '4',
  UnsupportedMarketdepth = '5',
  UnsupportedMdupdatetype = '6',
  UnsupportedAggregatedbook = '7',
  UnsupportedMdentrytype = '8',
  UnsupportedTradingsessionid = '9',
  UnsupportedScope = 'A',
  UnsupportedOpenclosesettleflag = 'B',
  UnsupportedMdimplicitdelete = 'C',
  InsufficientCredit = 'D'
}

export enum DeleteReason {
  CancelationTradeBust = '0',
  Error = '1'
}

export enum OpenCloseSettlFlag {
  DailyOpenCloseSettlementEntry = '0',
  SessionOpenCloseSettlementEntry = '1',
  DeliverySettlementEntry = '2',
  ExpectedEntry = '3',
  EntryFromPreviousBusinessDay = '4',
  TheoreticalPriceValue = '5'
}

export enum FinancialStatus {
  Bankrupt = '1',
  PendingDelisting = '2',
  Restricted = '3'
}

export enum CorporateAction {
  ExDividend = 'A',
  ExDistribution = 'B',
  ExRights = 'C',
  New = 'D',
  ExInterest = 'E',
  CashDividend = 'F',
  StockDividend = 'G',
  NonIntegerStockSplit = 'H',
  ReverseStockSplit = 'I',
  StandardIntegerStockSplit = 'J',
  PositionConsolidation = 'K',
  LiquidationReorganization = 'L',
  MergerReorganization = 'M',
  RightsOffering = 'N',
  ShareholderMeeting = 'O',
  Spinoff = 'P',
  TenderOffer = 'Q',
  Warrant = 'R',
  SpecialAction = 'S',
  SymbolConversion = 'T',
  Cusip = 'U',
  LeapRollover = 'V'
}

export enum QuoteStatus {
  Accepted = 0,
  CanceledForSymbol = 1,
  CanceledForSecurityType = 2,
  CanceledForUnderlying = 3,
  CanceledAll = 4,
  Rejected = 5,
  RemovedFromMarket = 6,
  Expired = 7,
  Query = 8,
  QuoteNotFound = 9,
  Pending = 10,
  Pass = 11,
  LockedMarketWarning = 12,
  CrossMarketWarning = 13,
  CanceledDueToLockMarket = 14,
  CanceledDueToCrossMarket = 15
}

export enum QuoteCancelType {
  CancelForSymbol = 1,
  CancelForSecurityType = 2,
  CancelForUnderlyingSymbol = 3,
  CancelAllQuotes = 4,
  CancelQuoteSpecifiedInQuoteid = 5
}

export enum QuoteRejectReason {
  UnknownSymbol = 1,
  ExchangeClosed = 2,
  QuoteRequestExceedsLimit = 3,
  TooLateToEnter = 4,
  UnknownQuote = 5,
  DuplicateQuote = 6,
  InvalidBidAskSpread = 7,
  InvalidPrice = 8,
  NotAuthorizedToQuoteSecurity = 9,
  Other = 99
}

export enum QuoteResponseLevel {
  NoAcknowledgement = 0,
  AcknowledgeOnlyNegativeOrErroneousQuotes = 1,
  AcknowledgeEachQuoteMessages = 2
}

export enum QuoteRequestType {
  Manual = 1,
  Automatic = 2
}

export enum SecurityRequestType {
  RequestSecurityIdentityAndSpecifications = 0,
  RequestSecurityIdentityForTheSpecificationsProvided = 1,
  RequestListSecurityTypes = 2,
  RequestListSecurities = 3
}

export enum SecurityResponseType {
  AcceptSecurityProposalAsIs = 1,
  AcceptSecurityProposalWithRevisionsAsIndicatedInTheMessage = 2,
  ListOfSecurityTypesReturnedPerRequest = 3,
  ListOfSecuritiesReturnedPerRequest = 4,
  RejectSecurityProposal = 5,
  CanNotMatchSelectionCriteria = 6
}

export enum SecurityTradingStatus {
  OpeningDelay = 1,
  TradingHalt = 2,
  Resume = 3,
  NoOpenNoResume = 4,
  PriceIndication = 5,
  TradingRangeIndication = 6,
  MarketImbalanceBuy = 7,
  MarketImbalanceSell = 8,
  MarketOnCloseImbalanceBuy = 9,
  MarketOnCloseImbalanceSell = 10,
  NotAssigned = 11,
  NoMarketImbalance = 12,
  NoMarketOnCloseImbalance = 13,
  ItsPreOpening = 14,
  NewPriceIndication = 15,
  TradeDisseminationTime = 16,
  ReadyToTradeStartOfSession = 17,
  NotAvailableForTradingEndOfSession = 18,
  NotTradedOnThisMarket = 19,
  UnknownOrInvalid = 20,
  PreOpen = 21,
  OpeningRotation = 22,
  FastMarket = 23
}

export enum HaltReason {
  NewsDissemination = 'D',
  OrderInflux = 'E',
  OrderImbalance = 'I',
  AdditionalInformation = 'M',
  NewsPending = 'P',
  EquipmentChangeover = 'X'
}

export enum Adjustment {
  Cancel = 1,
  Error = 2,
  Correction = 3
}

export enum TradSesMethod {
  Electronic = 1,
  OpenOutcry = 2,
  TwoParty = 3
}

export enum TradSesMode {
  Testing = 1,
  Simulated = 2,
  Production = 3
}

export enum TradSesStatus {
  Unknown = 0,
  Halted = 1,
  Open = 2,
  Closed = 3,
  PreOpen = 4,
  PreClose = 5,
  RequestRejected = 6,
  Disabled = 7
}

export enum MessageEncoding {
  Iso2022Jp = 'ISO-2022-JP',
  EucJp = 'EUC-JP',
  ShiftJis = 'SHIFT_JIS',
  Utf8 = 'UTF-8'
}

export enum QuoteEntryRejectReason {
  UnknownSymbol = 1,
  ExchangeClosed = 2,
  QuoteExceedsLimit = 3,
  TooLateToEnter = 4,
  UnknownQuote = 5,
  DuplicateQuote = 6,
  InvalidBidAskSpread = 7,
  InvalidPrice = 8,
  NotAuthorizedToQuoteSecurity = 9,
  Other = 99
}

export enum SessionRejectReason {
  InvalidTagNumber = 0,
  RequiredTagMissing = 1,
  TagNotDefinedForThisMessageType = 2,
  UndefinedTag = 3,
  TagSpecifiedWithoutAValue = 4,
  ValueIsIncorrect = 5,
  IncorrectDataFormatForValue = 6,
  DecryptionProblem = 7,
  SignatureProblem = 8,
  CompidProblem = 9,
  SendingtimeAccuracyProblem = 10,
  InvalidMsgtype = 11,
  XmlValidationError = 12,
  TagAppearsMoreThanOnce = 13,
  TagSpecifiedOutOfRequiredOrder = 14,
  RepeatingGroupFieldsOutOfOrder = 15,
  IncorrectNumingroupCountForRepeatingGroup = 16,
  NonDataValueIncludesFieldDelimiter = 17,
  Other = 99
}

export enum BidRequestTransType {
  Cancel = 'C',
  New = 'N'
}

export enum ExecRestatementReason {
  GtCorporateAction = 0,
  GtRenewalRestatement = 1,
  VerbalChange = 2,
  RepricingOfOrder = 3,
  BrokerOption = 4,
  PartialDeclineOfOrderqty = 5,
  CancelOnTradingHalt = 6,
  CancelOnSystemFailure = 7,
  MarketOption = 8,
  CanceledNotBest = 9,
  WarehouseRecap = 10,
  PegRefresh = 11,
  Other = 99
}

export enum BusinessRejectReason {
  Other = 0,
  UnkownId = 1,
  UnknownSecurity = 2,
  UnsupportedMessageType = 3,
  ApplicationNotAvailable = 4,
  ConditionallyRequiredFieldMissing = 5,
  NotAuthorized = 6,
  DelivertoFirmNotAvailableAtThisTime = 7,
  ThrottleLimitExceeded = 8,
  InvalidPriceIncrement = 18
}

export enum MsgDirection {
  Receive = 'R',
  Send = 'S'
}

export enum DiscretionInst {
  RelatedToDisplayedPrice = '0',
  RelatedToMarketPrice = '1',
  RelatedToPrimaryPrice = '2',
  RelatedToLocalPrimaryPrice = '3',
  RelatedToMidpointPrice = '4',
  RelatedToLastTradePrice = '5',
  RelatedToVwap = '6',
  AveragePriceGuarantee = '7'
}

export enum BidType {
  NonDisclosed = 1,
  DisclosedStyle = 2,
  NoBiddingProcess = 3
}

export enum BidDescriptorType {
  Sector = 1,
  Country = 2,
  Index = 3
}

export enum SideValueInd {
  Sidevalue1 = 1,
  Sidevalue2 = 2
}

export enum LiquidityIndType {
  FivedayMovingAverage = 1,
  TwentydayMovingAverage = 2,
  NormalMarketSize = 3,
  Other = 4
}

export enum ProgRptReqs {
  BuysideExplicitlyRequestsStatusUsingStatusrequest = 1,
  SellsidePeriodicallySendsStatusUsingListstatus = 2,
  RealTimeExecutionReports = 3
}

export enum IncTaxInd {
  Net = 1,
  Gross = 2
}

export enum BidTradeType {
  Agency = 'A',
  VwapGuarantee = 'G',
  GuaranteedClose = 'J',
  RiskTrade = 'R'
}

export enum BasisPxType {
  ClosingPriceAtMorningSession = '2',
  ClosingPrice = '3',
  CurrentPrice = '4',
  Sq = '5',
  VwapThroughADay = '6',
  VwapThroughAMorningSession = '7',
  VwapThroughAnAfternoonSession = '8',
  VwapThroughADayExceptYori = '9',
  VwapThroughAMorningSessionExceptYori = 'A',
  VwapThroughAnAfternoonSessionExceptYori = 'B',
  Strike = 'C',
  Open = 'D',
  Others = 'Z'
}

export enum PriceType {
  Percentage = 1,
  PerUnit = 2,
  FixedAmount = 3,
  Discount = 4,
  Premium = 5,
  Spread = 6,
  TedPrice = 7,
  TedYield = 8,
  Yield = 9,
  FixedCabinetTradePrice = 10,
  VariableCabinetTradePrice = 11,
  ProductTicksInHalfs = 13,
  ProductTicksInFourths = 14,
  ProductTicksInEights = 15,
  ProductTicksInSixteenths = 16,
  ProductTicksInThirtySeconds = 17,
  ProductTicksInSixtyForths = 18,
  ProductTicksInOneTwentyEights = 19
}

export enum GTBookingInst {
  BookOutAllTradesOnDayOfExecution = 0,
  AccumulateExecutionsUntilOrderIsFilledOrExpires = 1,
  AccumulateUntilVerballyNotifiedOtherwise = 2
}

export enum ListStatusType {
  Ack = 1,
  Response = 2,
  Timed = 3,
  Execstarted = 4,
  Alldone = 5,
  Alert = 6
}

export enum NetGrossInd {
  Net = 1,
  Gross = 2
}

export enum ListOrderStatus {
  Inbiddingprocess = 1,
  Receivedforexecution = 2,
  Executing = 3,
  Canceling = 4,
  Alert = 5,
  AllDone = 6,
  Reject = 7
}

export enum ListExecInstType {
  Immediate = '1',
  WaitForExecuteInstruction = '2',
  ExchangeSwitchCivOrderSellDriven = '3',
  ExchangeSwitchCivOrderBuyDrivenCashTopUp = '4',
  ExchangeSwitchCivOrderBuyDrivenCashWithdraw = '5'
}

export enum CxlRejResponseTo {
  OrderCancelRequest = '1',
  OrderCancelReplaceRequest = '2'
}

export enum MultiLegReportingType {
  SingleSecurity = '1',
  IndividualLegOfAMultiLegSecurity = '2',
  MultiLegSecurity = '3'
}

export enum PartyIDSource {
  KoreanInvestorId = '1',
  TaiwaneseQualifiedForeignInvestorIdQfiiFid = '2',
  TaiwaneseTradingAccount = '3',
  MalaysianCentralDepositoryNumber = '4',
  ChineseBShare = '5',
  UkNationalInsuranceOrPensionNumber = '6',
  UsSocialSecurityNumber = '7',
  UsEmployerIdentificationNumber = '8',
  AustralianBusinessNumber = '9',
  AustralianTaxFileNumber = 'A',
  Bic = 'B',
  GenerallyAcceptedMarketParticipantIdentifier = 'C',
  ProprietaryCustomCode = 'D',
  IsoCountryCode = 'E',
  SettlementEntityLocation = 'F',
  Mic = 'G',
  CsdParticipantMemberCode = 'H',
  DirectedBroker = 'I'
}

export enum PartyRole {
  ExecutingFirm = 1,
  BrokerOfCredit = 2,
  ClientId = 3,
  ClearingFirm = 4,
  InvestorId = 5,
  IntroducingFirm = 6,
  EnteringFirm = 7,
  LocateLendingFirm = 8,
  FundManagerClientId = 9,
  SettlementLocation = 10,
  OrderOriginationTrader = 11,
  ExecutingTrader = 12,
  OrderOriginationFirm = 13,
  GiveupClearingFirm = 14,
  CorrespondantClearingFirm = 15,
  ExecutingSystem = 16,
  ContraFirm = 17,
  ContraClearingFirm = 18,
  SponsoringFirm = 19,
  UnderlyingContraFirm = 20,
  ClearingOrganization = 21,
  Exchange = 22,
  CustomerAccount = 24,
  CorrespondentClearingOrganization = 25,
  CorrespondentBroker = 26,
  BuyerSeller = 27,
  Custodian = 28,
  Intermediary = 29,
  Agent = 30,
  SubCustodian = 31,
  Beneficiary = 32,
  InterestedParty = 33,
  RegulatoryBody = 34,
  LiquidityProvider = 35,
  EnteringTrader = 36,
  ContraTrader = 37,
  PositionAccount = 38,
  ContraInvestorId = 39,
  TransferToFirm = 40,
  ContraPositionAccount = 41,
  ContraExchange = 42,
  InternalCarryAccount = 43,
  OrderEntryOperatorId = 44,
  SecondaryAccountNumber = 45,
  ForiegnFirm = 46,
  ThirdPartyAllocationFirm = 47,
  ClaimingAccount = 48,
  AssetManager = 49,
  PledgorAccount = 50,
  PledgeeAccount = 51,
  LargeTraderReportableAccount = 52,
  TraderMnemonic = 53,
  SenderLocation = 54,
  SessionId = 55,
  AcceptableCounterparty = 56,
  UnacceptableCounterparty = 57,
  EnteringUnit = 58,
  ExecutingUnit = 59,
  IntroducingBroker = 60,
  QuoteOriginator = 61,
  ReportOriginator = 62,
  SystematicInternaliser = 63,
  MultilateralTradingFacility = 64,
  RegulatedMarket = 65,
  MarketMaker = 66,
  InvestmentFirm = 67,
  HostCompetentAuthority = 68,
  HomeCompetentAuthority = 69,
  CompetentAuthorityOfTheMostRelevantMarketInTermsOfLiquidity = 70,
  CompetentAuthorityOfTheTransaction = 71,
  ReportingIntermediary = 72,
  ExecutionVenue = 73,
  MarketDataEntryOriginator = 74,
  LocationId = 75,
  DeskId = 76,
  MarketDataMarket = 77,
  AllocationEntity = 78,
  GiveUpFirm = 95,
  TakeUpFirm = 96
}

export enum Product {
  Agency = 1,
  Commodity = 2,
  Corporate = 3,
  Currency = 4,
  Equity = 5,
  Government = 6,
  Index = 7,
  Loan = 8,
  Moneymarket = 9,
  Mortgage = 10,
  Municipal = 11,
  Other = 12,
  Financing = 13
}

export enum QuantityType {
  Shares = 1,
  Bonds = 2,
  Currentface = 3,
  Originalface = 4,
  Currency = 5,
  Contracts = 6,
  Other = 7,
  Par = 8
}

export enum RoundingDirection {
  RoundToNearest = '0',
  RoundDown = '1',
  RoundUp = '2'
}

export enum DistribPaymentMethod {
  Crest = 1,
  Nscc = 2,
  Euroclear = 3,
  Clearstream = 4,
  Cheque = 5,
  TelegraphicTransfer = 6,
  Fedwire = 7,
  DirectCredit = 8,
  AchCredit = 9,
  Bpay = 10,
  HighValueClearingSystemHvacs = 11,
  ReinvestInFund = 12
}

export enum CancellationRights {
  NoExecutionOnly = 'N',
  NoWaiverAgreement = 'M',
  NoInstitutional = 'O',
  Yes = 'Y'
}

export enum MoneyLaunderingStatus {
  ExemptBelowTheLimit = '1',
  ExemptClientMoneyTypeExemption = '2',
  ExemptAuthorisedCreditOrFinancialInstitution = '3',
  Passed = 'Y',
  NotChecked = 'N'
}

export enum ExecPriceType {
  BidPrice = 'B',
  CreationPrice = 'C',
  CreationPricePlusAdjustmentPercent = 'D',
  CreationPricePlusAdjustmentAmount = 'E',
  OfferPrice = 'O',
  OfferPriceMinusAdjustmentPercent = 'P',
  OfferPriceMinusAdjustmentAmount = 'Q',
  SinglePrice = 'S'
}

export enum TradeReportTransType {
  New = 0,
  Cancel = 1,
  Replace = 2,
  Release = 3,
  Reverse = 4,
  CancelDueToBackOutOfTrade = 5
}

export enum PaymentMethod {
  Crest = 1,
  Nscc = 2,
  Euroclear = 3,
  Clearstream = 4,
  Cheque = 5,
  TelegraphicTransfer = 6,
  Fedwire = 7,
  DebitCard = 8,
  DirectDebit = 9,
  DirectCredit = 10,
  CreditCard = 11,
  AchDebit = 12,
  AchCredit = 13,
  Bpay = 14,
  HighValueClearingSystem = 15
}

export enum TaxAdvantageType {
  None = 0,
  MaxiIsa = 1,
  Tessa = 2,
  MiniCashIsa = 3,
  MiniStocksAndSharesIsa = 4,
  MiniInsuranceIsa = 5,
  CurrentYearPayment = 6,
  PriorYearPayment = 7,
  AssetTransfer = 8,
  EmployeePriorYear = 9,
  Employee = 10,
  Employer = 11,
  Employer2 = 12,
  NonFundPrototypeIra = 13,
  NonFundQualifiedPlan = 14,
  DefinedContributionPlan = 15,
  IndividualRetirementAccount = 16,
  IndividualRetirementAccount2 = 17,
  Keogh = 18,
  ProfitSharingPlan = 19,
  E401K = 20,
  SelfDirectedIra = 21,
  E403B = 22,
  E457 = 23,
  RothIra = 24,
  RothIra2 = 25,
  RothConversionIra = 26,
  RothConversionIra2 = 27,
  EducationIra = 28,
  EducationIra2 = 29,
  Other = 999
}

export enum FundRenewWaiv {
  No = 'N',
  Yes = 'Y'
}

export enum RegistStatus {
  Accepted = 'A',
  Rejected = 'R',
  Held = 'H',
  Reminder = 'N'
}

export enum RegistRejReasonCode {
  InvalidUnacceptableAccountType = 1,
  InvalidUnacceptableTaxExemptType = 2,
  InvalidUnacceptableOwnershipType = 3,
  InvalidUnacceptableNoRegDetls = 4,
  InvalidUnacceptableRegSeqNo = 5,
  InvalidUnacceptableRegDtls = 6,
  InvalidUnacceptableMailingDtls = 7,
  InvalidUnacceptableMailingInst = 8,
  InvalidUnacceptableInvestorId = 9,
  InvalidUnacceptableInvestorIdSource = 10,
  InvalidUnacceptableDateOfBirth = 11,
  InvalidUnacceptableInvestorCountryOfResidence = 12,
  InvalidUnacceptableNodistribinstns = 13,
  InvalidUnacceptableDistribPercentage = 14,
  InvalidUnacceptableDistribPaymentMethod = 15,
  InvalidUnacceptableCashDistribAgentAcctName = 16,
  InvalidUnacceptableCashDistribAgentCode = 17,
  InvalidUnacceptableCashDistribAgentAcctNum = 18,
  Other = 99
}

export enum RegistTransType {
  New = '0',
  Replace = '1',
  Cancel = '2'
}

export enum OwnershipType {
  JointTrustees = '2',
  JointInvestors = 'J',
  TenantsInCommon = 'T'
}

export enum ContAmtType {
  CommissionAmount = 1,
  CommissionPercent = 2,
  InitialChargeAmount = 3,
  InitialChargePercent = 4,
  DiscountAmount = 5,
  DiscountPercent = 6,
  DilutionLevyAmount = 7,
  DilutionLevyPercent = 8,
  ExitChargeAmount = 9,
  ExitChargePercent = 10,
  FundBasedRenewalCommissionPercent = 11,
  ProjectedFundValue = 12,
  FundBasedRenewalCommissionAmount = 13,
  FundBasedRenewalCommissionAmount2 = 14,
  NetSettlementAmount = 15
}

export enum OwnerType {
  IndividualInvestor = 1,
  PublicCompany = 2,
  PrivateCompany = 3,
  IndividualTrustee = 4,
  CompanyTrustee = 5,
  PensionPlan = 6,
  CustodianUnderGiftsToMinorsAct = 7,
  Trusts = 8,
  Fiduciaries = 9,
  NetworkingSubAccount = 10,
  NonProfitOrganization = 11,
  CorporateBody = 12,
  Nominee = 13
}

export enum OrderCapacity {
  Agency = 'A',
  Proprietary = 'G',
  Individual = 'I',
  Principal = 'P',
  RisklessPrincipal = 'R',
  AgentForOtherMember = 'W'
}

export enum OrderRestrictions {
  ProgramTrade = '1',
  IndexArbitrage = '2',
  NonIndexArbitrage = '3',
  CompetingMarketMaker = '4',
  ActingAsMarketMakerOrSpecialistInTheSecurity = '5',
  ActingAsMarketMakerOrSpecialistInTheUnderlyingSecurityOfADerivativeSecurity = '6',
  ForeignEntity = '7',
  ExternalMarketParticipant = '8',
  ExternalInterConnectedMarketLinkage = '9',
  RisklessArbitrage = 'A'
}

export enum MassCancelRequestType {
  CancelOrdersForASecurity = '1',
  CancelOrdersForAnUnderlyingSecurity = '2',
  CancelOrdersForAProduct = '3',
  CancelOrdersForACficode = '4',
  CancelOrdersForASecuritytype = '5',
  CancelOrdersForATradingSession = '6',
  CancelAllOrders = '7',
  CancelOrdersForAMarket = '8',
  CancelOrdersForAMarketSegment = '9',
  CancelOrdersForASecurityGroup = 'A',
  CancelOrdersForASecurityB = 'B',
  CancelForIssuerOfUnderlyingSecurity = 'C'
}

export enum MassCancelResponse {
  CancelRequestRejected = '0',
  CancelOrdersForASecurity = '1',
  CancelOrdersForAnUnderlyingSecurity = '2',
  CancelOrdersForAProduct = '3',
  CancelOrdersForACficode = '4',
  CancelOrdersForASecuritytype = '5',
  CancelOrdersForATradingSession = '6',
  CancelAllOrders = '7',
  CancelOrdersForAMarket = '8',
  CancelOrdersForAMarketSegment = '9',
  CancelOrdersForASecurityGroup = 'A',
  CancelOrdersForASecurityB = 'B',
  CancelForIssuerOfUnderlyingSecurity = 'C'
}

export enum MassCancelRejectReason {
  MassCancelNotSupported = 0,
  InvalidOrUnknownSecurity = 1,
  InvalidOrUnknownUnderlying = 2,
  InvalidOrUnknownProduct = 3,
  InvalidOrUnknownCficode = 4,
  InvalidOrUnknownSecurityType = 5,
  InvalidOrUnknownTradingSession = 6,
  InvalidOrUnknownMarket = 7,
  InvalidOrUnknownMarketSegment = 8,
  InvalidOrUnknownSecurityGroup = 9,
  Other = 99
}

export enum QuoteType {
  Indicative = 0,
  Tradeable = 1,
  RestrictedTradeable = 2,
  Counter = 3
}

export enum CashMargin {
  Cash = '1',
  MarginOpen = '2',
  MarginClose = '3'
}

export enum Scope {
  Local = '1',
  National = '2',
  Global = '3'
}

export enum CrossType {
  CrossTradeWhichIsExecutedCompletelyOrNot = 1,
  CrossTradeWhichIsExecutedPartiallyAndTheRestIsCancelled = 2,
  CrossTradeWhichIsPartiallyExecutedWithTheUnfilledPortionsRemainingActive = 3,
  CrossTradeIsExecutedWithExistingOrdersWithTheSamePrice = 4
}

export enum CrossPrioritization {
  None = 0,
  BuySideIsPrioritized = 1,
  SellSideIsPrioritized = 2
}

export enum NoSides {
  OneSide = 1,
  BothSides = 2
}

export enum SecurityListRequestType {
  Symbol = 0,
  SecuritytypeAndOrCficode = 1,
  Product = 2,
  Tradingsessionid = 3,
  AllSecurities = 4
}

export enum SecurityRequestResult {
  ValidRequest = 0,
  InvalidOrUnsupportedRequest = 1,
  NoInstrumentsFoundThatMatchSelectionCriteria = 2,
  NotAuthorizedToRetrieveInstrumentData = 3,
  InstrumentDataTemporarilyUnavailable = 4,
  RequestForInstrumentDataNotSupported = 5
}

export enum MultiLegRptTypeReq {
  ReportByMulitlegSecurityOnly = 0,
  ReportByMultilegSecurityAndByInstrumentLegsBelongingToTheMultilegSecurity = 1,
  ReportByInstrumentLegsBelongingToTheMultilegSecurityOnly = 2
}

export enum TradSesStatusRejReason {
  UnknownOrInvalidTradingsessionid = 1,
  Other = 99
}

export enum TradeRequestType {
  AllTrades = 0,
  MatchedTradesMatchingCriteriaProvidedOnRequest = 1,
  UnmatchedTradesThatMatchCriteria = 2,
  UnreportedTradesThatMatchCriteria = 3,
  AdvisoriesThatMatchCriteria = 4
}

export enum MatchStatus {
  ComparedMatchedOrAffirmed = '0',
  UncomparedUnmatchedOrUnaffirmed = '1',
  AdvisoryOrAlert = '2'
}

export enum MatchType {
  OnePartyTradeReport = '1',
  TwoPartyTradeReport = '2',
  ConfirmedTradeReport = '3',
  AutoMatch = '4',
  CrossAuction = '5',
  CounterOrderSelection = '6',
  CallAuction = '7',
  OnePartyPrivatelyNegotiatedTradeReport = '60',
  TwoPartyPrivatelyNegotiatedTradeReport = '61',
  ContinuousAutoMatch = '62',
  CrossAuction2 = '63',
  CounterOrderSelection2 = '64',
  CallAuction2 = '65',
  ExactPlusFourBadgesAndExecutionTime = 'A1',
  ExactPlusFourBadges = 'A2',
  ExactPlusTwoBadgesAndExecutionTime = 'A3',
  ExactPlusTwoBadges = 'A4',
  ExactPlusExecutionTime = 'A5',
  ActAcceptedTrade = 'M3',
  ActDefaultTrade = 'M4',
  ActDefaultAfterM2 = 'M5',
  ActM6Match = 'M6',
  ComparedRecordsResultingFromStampedAdvisoriesOrSpecialistAcceptsPairOffs = 'AQ',
  ExactMatchOnTradeDateStockSymbolQuantityPriceTradeTypeAndSpecialTradeIndicatorMinusBadgesAndTimesActM1Match = 'M1',
  SummarizedMatchMinusBadgesAndTimesActM2Match = 'M2',
  OcsLockedInNonAct = 'MT',
  SummarizedMatchUsingA1ExactMatchCriteriaExceptQuantityIsSummaried = 'S1',
  SummarizedMatchUsingA2ExactMatchCriteriaExceptQuantityIsSummarized = 'S2',
  SummarizedMatchUsingA3ExactMatchCriteriaExceptQuantityIsSummarized = 'S3',
  SummarizedMatchUsingA4ExactMatchCriteriaExceptQuantityIsSummarized = 'S4',
  SummarizedMatchUsingA5ExactMatchCriteriaExceptQuantityIsSummarized = 'S5'
}

export enum ClearingInstruction {
  ProcessNormally = 0,
  ExcludeFromAllNetting = 1,
  BilateralNettingOnly = 2,
  ExClearing = 3,
  SpecialTrade = 4,
  MultilateralNetting = 5,
  ClearAgainstCentralCounterparty = 6,
  ExcludeFromCentralCounterparty = 7,
  ManualMode = 8,
  AutomaticPostingMode = 9,
  AutomaticGiveUpMode = 10,
  QualifiedServiceRepresentativeQsr = 11,
  CustomerTrade = 12,
  SelfClearing = 13
}

export enum AccountType {
  AccountIsCarriedOnCustomerSideOfBooks = 1,
  AccountIsCarriedOnNonCustomerSideOfBooks = 2,
  HouseTrader = 3,
  FloorTrader = 4,
  AccountIsCarriedOnNonCustomerSideOfBooksAndIsCrossMargined = 6,
  AccountIsHouseTraderAndIsCrossMargined = 7,
  JointBackofficeAccount = 8
}

export enum CustOrderCapacity {
  MemberTradingForTheirOwnAccount = 1,
  ClearingFirmTradingForItsProprietaryAccount = 2,
  MemberTradingForAnotherMember = 3,
  AllOther = 4
}

export enum MassStatusReqType {
  StatusForOrdersForASecurity = 1,
  StatusForOrdersForAnUnderlyingSecurity = 2,
  StatusForOrdersForAProduct = 3,
  StatusForOrdersForACficode = 4,
  StatusForOrdersForASecuritytype = 5,
  StatusForOrdersForATradingSession = 6,
  StatusForAllOrders = 7,
  StatusForOrdersForAPartyid = 8
}

export enum DayBookingInst {
  CanTriggerBookingWithoutReferenceToTheOrderInitiator = '0',
  SpeakWithOrderInitiatorBeforeBooking = '1',
  Accumulate = '2'
}

export enum BookingUnit {
  EachPartialExecutionIsABookableUnit = '0',
  AggregatePartialExecutionsOnThisOrderAndBookOneTradePerOrder = '1',
  AggregateExecutionsForThisSymbolSideAndSettlementDate = '2'
}

export enum PreallocMethod {
  ProRata = '0',
  DoNotProRata = '1'
}

export enum AllocType {
  Calculated = 1,
  Preliminary = 2,
  SellsideCalculatedUsingPreliminary = 3,
  SellsideCalculatedWithoutPreliminary = 4,
  ReadyToBookSingleOrder = 5,
  BuysideReadyToBook = 6,
  WarehouseInstruction = 7,
  RequestToIntermediary = 8,
  Accept = 9,
  Reject = 10,
  AcceptPending = 11,
  IncompleteGroup = 12,
  CompleteGroup = 13,
  ReversalPending = 14
}

export enum ClearingFeeIndicator {
  E1stYearDelegateTradingForOwnAccount = '1',
  E2ndYearDelegateTradingForOwnAccount = '2',
  E3rdYearDelegateTradingForOwnAccount = '3',
  E4thYearDelegateTradingForOwnAccount = '4',
  E5thYearDelegateTradingForOwnAccount = '5',
  E6thYearDelegateTradingForOwnAccount = '9',
  CboeMember = 'B',
  NonMemberAndCustomer = 'C',
  EquityMemberAndClearingMember = 'E',
  FullAndAssociateMemberTradingForOwnAccountAndAsFloorBrokers = 'F',
  Firms106HAnd106J = 'H',
  GimIdemAndComMembershipInterestHolders = 'I',
  LesseeAnd106FEmployees = 'L',
  AllOtherOwnershipTypes = 'M'
}

export enum PriorityIndicator {
  PriorityUnchanged = 0,
  LostPriorityAsResultOfOrderChange = 1
}

export enum SecDefStatus {
  PendingApproval = 0,
  Approved = 1,
  Rejected = 2,
  UnauthorizedRequest = 3,
  InvalidDefinitionRequest = 4
}

export enum QuoteRequestRejectReason {
  UnknownSymbol = 1,
  ExchangeClosed = 2,
  QuoteRequestExceedsLimit = 3,
  TooLateToEnter = 4,
  InvalidPrice = 5,
  NotAuthorizedToRequestQuote = 6,
  NoMatchForInquiry = 7,
  NoMarketForInstrument = 8,
  NoInventory = 9,
  Pass = 10,
  InsufficientCredit = 11,
  Other = 99
}

export enum AcctIDSource {
  Bic = 1,
  SidCode = 2,
  Tfm = 3,
  Omgeo = 4,
  DtccCode = 5,
  Other = 99
}

export enum ConfirmStatus {
  Received = 1,
  MismatchedAccount = 2,
  MissingSettlementInstructions = 3,
  Confirmed = 4,
  RequestRejected = 5
}

export enum ConfirmTransType {
  New = 0,
  Replace = 1,
  Cancel = 2
}

export enum DeliveryForm {
  Bookentry = 1,
  Bearer = 2
}

export enum LegSwapType {
  ParForPar = 1,
  ModifiedDuration = 2,
  Risk = 4,
  Proceeds = 5
}

export enum QuotePriceType {
  Percent = 1,
  PerShare = 2,
  FixedAmount = 3,
  Discount = 4,
  Premium = 5,
  BasisPointsRelativeToBenchmark = 6,
  TedPrice = 7,
  TedYield = 8,
  YieldSpread = 9,
  Yield = 10
}

export enum QuoteRespType {
  HitLift = 1,
  Counter = 2,
  Expired = 3,
  Cover = 4,
  DoneAway = 5,
  Pass = 6
}

export enum PosType {
  TransactionQuantity = 'TQ',
  IntraSpreadQty = 'IAS',
  InterSpreadQty = 'IES',
  EndOfDayQty = 'FIN',
  StartOfDayQty = 'SOD',
  OptionExerciseQty = 'EX',
  OptionAssignment = 'AS',
  TransactionFromExercise = 'TX',
  TransactionFromAssignment = 'TA',
  PitTradeQty = 'PIT',
  TransferTradeQty = 'TRF',
  ElectronicTradeQty = 'ETR',
  AllocationTradeQty = 'ALC',
  AdjustmentQty = 'PA',
  AsOfTradeQty = 'ASF',
  DeliveryQty = 'DLV',
  TotalTransactionQty = 'TOT',
  CrossMarginQty = 'XM',
  IntegralSplit = 'SPL',
  ReceiveQuantity = 'RCV',
  CorporateActionAdjustment = 'CAA',
  DeliveryNoticeQty = 'DN',
  ExchangeForPhysicalQty = 'EP'
}

export enum PosQtyStatus {
  Submitted = 0,
  Accepted = 1,
  Rejected = 2
}

export enum PosAmtType {
  FinalMarkToMarketAmount = 'FMTM',
  IncrementalMarkToMarketAmount = 'IMTM',
  TradeVariationAmount = 'TVAR',
  StartOfDayMarkToMarketAmount = 'SMTM',
  PremiumAmount = 'PREM',
  CashResidualAmount = 'CRES',
  CashAmount = 'CASH',
  ValueAdjustedAmount = 'VADJ',
  SettlementValue = 'SETL'
}

export enum PosTransType {
  Exercise = 1,
  DoNotExercise = 2,
  PositionAdjustment = 3,
  PositionChangeSubmissionMarginDisposition = 4,
  Pledge = 5,
  LargeTraderSubmission = 6
}

export enum PosMaintAction {
  New = 1,
  Replace = 2,
  Cancel = 3,
  Reverse = 4
}

export enum SettlSessID {
  Intraday = 'ITD',
  RegularTradingHours = 'RTH',
  ElectronicTradingHours = 'ETH',
  EndOfDay = 'EOD'
}

export enum AdjustmentType {
  ProcessRequestAsMarginDisposition = 0,
  DeltaPlus = 1,
  DeltaMinus = 2,
  Final = 3
}

export enum PosMaintStatus {
  Accepted = 0,
  AcceptedWithWarnings = 1,
  Rejected = 2,
  Completed = 3,
  CompletedWithWarnings = 4
}

export enum PosMaintResult {
  SuccessfulCompletionNoWarningsOrErrors = 0,
  Rejected = 1,
  Other = 99
}

export enum PosReqType {
  Positions = 0,
  Trades = 1,
  Exercises = 2,
  Assignments = 3,
  SettlementActivity = 4,
  BackoutMessage = 5
}

export enum ResponseTransportType {
  Inband = 0,
  OutOfBand = 1
}

export enum PosReqResult {
  ValidRequest = 0,
  InvalidOrUnsupportedRequest = 1,
  NoPositionsFoundThatMatchCriteria = 2,
  NotAuthorizedToRequestPositions = 3,
  RequestForPositionNotSupported = 4,
  Other = 99
}

export enum PosReqStatus {
  Completed = 0,
  CompletedWithWarnings = 1,
  Rejected = 2
}

export enum SettlPriceType {
  Final = 1,
  Theoretical = 2
}

export enum AssignmentMethod {
  Random = 'R',
  Prorata = 'P'
}

export enum ExerciseMethod {
  Automatic = 'A',
  Manual = 'M'
}

export enum TradeRequestResult {
  Successful = 0,
  InvalidOrUnknownInstrument = 1,
  InvalidTypeOfTradeRequested = 2,
  InvalidParties = 3,
  InvalidTransportTypeRequested = 4,
  InvalidDestinationRequested = 5,
  TraderequesttypeNotSupported = 8,
  UnauthorizedForTradeCaptureReportRequest = 9,
  Other = 99
}

export enum TradeRequestStatus {
  Accepted = 0,
  Completed = 1,
  Rejected = 2
}

export enum TradeReportRejectReason {
  Successful = 0,
  InvalidPartyInformation = 1,
  UnknownInstrument = 2,
  UnauthorizedToReportTrades = 3,
  InvalidTradeType = 4,
  Other = 99
}

export enum SideMultiLegReportingType {
  SingleSecurity = 1,
  IndividualLegOfAMultiLegSecurity = 2,
  MultiLegSecurity = 3
}

export enum TrdRegTimestampType {
  ExecutionTime = 1,
  TimeIn = 2,
  TimeOut = 3,
  BrokerReceipt = 4,
  BrokerExecution = 5,
  DeskReceipt = 6
}

export enum ConfirmType {
  Status = 1,
  Confirmation = 2,
  ConfirmationRequestRejected = 3
}

export enum ConfirmRejReason {
  MismatchedAccount = 1,
  MissingSettlementInstructions = 2,
  Other = 99
}

export enum BookingType {
  RegularBooking = 0,
  Cfd = 1,
  TotalReturnSwap = 2
}

export enum AllocSettlInstType {
  UseDefaultInstructions = 0,
  DeriveFromParametersProvided = 1,
  FullDetailsProvided = 2,
  SsiDbIdsProvided = 3,
  PhoneForInstructions = 4
}

export enum DlvyInstType {
  Securities = 'S',
  Cash = 'C'
}

export enum TerminationType {
  Overnight = 1,
  Term = 2,
  Flexible = 3,
  Open = 4
}

export enum SettlInstReqRejCode {
  UnableToProcessRequest = 0,
  UnknownAccount = 1,
  NoMatchingSettlementInstructionsFound = 2,
  Other = 99
}

export enum AllocReportType {
  PreliminaryRequestToIntermediary = 2,
  SellsideCalculatedUsingPreliminary = 3,
  SellsideCalculatedWithoutPreliminary = 4,
  WarehouseRecap = 5,
  RequestToIntermediary = 8,
  Accept = 9,
  Reject = 10,
  AcceptPending = 11,
  Complete = 12,
  ReversePending = 14
}

export enum AllocCancReplaceReason {
  OriginalDetailsIncompleteIncorrect = 1,
  ChangeInUnderlyingOrderDetails = 2,
  Other = 99
}

export enum AllocAccountType {
  AccountIsCarriedOnCustomerSideOfBooks = 1,
  AccountIsCarriedOnNonCustomerSideOfBooks = 2,
  HouseTrader = 3,
  FloorTrader = 4,
  AccountIsCarriedOnNonCustomerSideOfBooksAndIsCrossMargined = 6,
  AccountIsHouseTraderAndIsCrossMargined = 7,
  JointBackofficeAccount = 8
}

export enum PartySubIDType {
  Firm = 1,
  Person = 2,
  System = 3,
  Application = 4,
  FullLegalNameOfFirm = 5,
  PostalAddress = 6,
  PhoneNumber = 7,
  EmailAddress = 8,
  ContactName = 9,
  SecuritiesAccountNumber = 10,
  RegistrationNumber = 11,
  RegisteredAddress = 12,
  RegulatoryStatus = 13,
  RegistrationName = 14,
  CashAccountNumber = 15,
  Bic = 16,
  CsdParticipantMemberCode = 17,
  RegisteredAddress2 = 18,
  FundAccountName = 19,
  TelexNumber = 20,
  FaxNumber = 21,
  SecuritiesAccountName = 22,
  CashAccountName = 23,
  Department = 24,
  LocationDesk = 25,
  PositionAccountType = 26,
  SecurityLocateId = 27,
  MarketMaker = 28,
  EligibleCounterparty = 29,
  ProfessionalClient = 30,
  Location = 31,
  ExecutionVenue = 32
}

export enum AllocIntermedReqType {
  PendingAccept = 1,
  PendingRelease = 2,
  PendingReversal = 3,
  Accept = 4,
  BlockLevelReject = 5,
  AccountLevelReject = 6
}

export enum ApplQueueResolution {
  NoActionTaken = 0,
  QueueFlushed = 1,
  OverlayLast = 2,
  EndSession = 3
}

export enum ApplQueueAction {
  NoActionTaken = 0,
  QueueFlushed = 1,
  OverlayLast = 2,
  EndSession = 3
}

export enum AvgPxIndicator {
  NoAveragePricing = 0,
  TradeIsPartOfAnAveragePriceGroupIdentifiedByTheTradelinkid = 1,
  LastTradeInTheAveragePriceGroupIdentifiedByTheTradelinkid = 2
}

export enum TradeAllocIndicator {
  AllocationNotRequired = 0,
  AllocationRequired = 1,
  UseAllocationProvidedWithTheTrade = 2,
  AllocationGiveUpExecutor = 3,
  AllocationFromExecutor = 4,
  AllocationToClaimAccount = 5
}

export enum ExpirationCycle {
  ExpireOnTradingSessionClose = 0,
  ExpireOnTradingSessionOpen = 1
}

export enum TrdType {
  RegularTrade = 0,
  BlockTrade = 1,
  Efp = 2,
  Transfer = 3,
  LateTrade = 4,
  TTrade = 5,
  WeightedAveragePriceTrade = 6,
  BunchedTrade = 7,
  LateBunchedTrade = 8,
  PriorReferencePriceTrade = 9,
  AfterHoursTrade = 10,
  ExchangeForRisk = 11,
  ExchangeForSwap = 12,
  ExchangeOfFuturesFor = 13,
  ExchangeOfOptionsForOptions = 14,
  TradingAtSettlement = 15,
  AllOrNone = 16,
  FuturesLargeOrderExecution = 17,
  ExchangeOfFuturesForFutures = 18,
  OptionInterimTrade = 19,
  OptionCabinetTrade = 20,
  PrivatelyNegotiatedTrades = 22,
  SubstitutionOfFuturesForForwards = 23,
  ErrorTrade = 24,
  SpecialCumDividend = 25,
  SpecialExDividend = 26,
  SpecialCumCoupon = 27,
  SpecialExCoupon = 28,
  CashSettlement = 29,
  SpecialPrice = 30,
  GuaranteedDelivery = 31,
  SpecialCumRights = 32,
  SpecialExRights = 33,
  SpecialCumCapitalRepayments = 34,
  SpecialExCapitalRepayments = 35,
  SpecialCumBonus = 36,
  SpecialExBonus = 37,
  BlockTrade2 = 38,
  WorkedPrincipalTrade = 39,
  BlockTrades = 40,
  NameChange = 41,
  PortfolioTransfer = 42,
  ProrogationBuy = 43,
  ProrogationSell = 44,
  OptionExercise = 45,
  DeltaNeutralTransaction = 46,
  FinancingTransaction = 47,
  Allocation = 1001,
  Giveup = 1002,
  Floor = 1003,
  Rfq = 1004,
  FloorBlockTrade = 1005
}

export enum TrdSubType {
  Cmta = 0,
  InternalTransferOrAdjustment = 1,
  ExternalTransferOrTransferOfAccount = 2,
  RejectForSubmittingSide = 3,
  AdvisoryForContraSide = 4,
  OffsetDueToAnAllocation = 5,
  OnsetDutToAnAllocation = 6,
  DifferentialSpread = 7,
  ImpliedSpreadLegExecutedAgainstAnOutright = 8,
  TransactionFromExercise = 9,
  TransactionFromAssignment = 10,
  Acats = 11,
  Ai = 14,
  B = 15,
  K = 16,
  Lc = 17,
  M = 18,
  N = 19,
  Nm = 20,
  Nr = 21,
  P = 22,
  Pa = 23,
  Pc = 24,
  Pn = 25,
  R = 26,
  Ro = 27,
  Rt = 28,
  Sw = 29,
  T = 30,
  Wn = 31,
  Wt = 32
}

export enum PegMoveType {
  Floating = 0,
  Fixed = 1
}

export enum PegOffsetType {
  Price = 0,
  BasisPoints = 1,
  Ticks = 2,
  PriceTierLevel = 3
}

export enum PegLimitType {
  OrBetter = 0,
  Strict = 1,
  OrWorse = 2
}

export enum PegRoundDirection {
  MoreAggressive = 1,
  MorePassive = 2
}

export enum PegScope {
  Local = 1,
  National = 2,
  Global = 3,
  NationalExcludingLocal = 4
}

export enum DiscretionMoveType {
  Floating = 0,
  Fixed = 1
}

export enum DiscretionOffsetType {
  Price = 0,
  BasisPoints = 1,
  Ticks = 2,
  PriceTierLevel = 3
}

export enum DiscretionLimitType {
  OrBetter = 0,
  Strict = 1,
  OrWorse = 2
}

export enum DiscretionRoundDirection {
  MoreAggressive = 1,
  MorePassive = 2
}

export enum DiscretionScope {
  Local = 1,
  National = 2,
  Global = 3,
  NationalExcludingLocal = 4
}

export enum TargetStrategy {
  Vwap = 1,
  Participate = 2,
  MininizeMarketImpact = 3
}

export enum LastLiquidityInd {
  AddedLiquidity = 1,
  RemovedLiquidity = 2,
  LiquidityRoutedOut = 3
}

export enum ShortSaleReason {
  DealerSoldShort = 0,
  DealerSoldShortExempt = 1,
  SellingCustomerSoldShort = 2,
  SellingCustomerSoldShortExempt = 3,
  QualifedServiceRepresentativeOrAutomaticGiveupContraSideSoldShort = 4,
  QsrOrAguContraSideSoldShortExempt = 5
}

export enum QtyType {
  Units = 0,
  Contracts = 1,
  UnitsOfMeasurePerTimeUnit = 2
}

export enum TradeReportType {
  Submit = 0,
  Alleged = 1,
  Accept = 2,
  Decline = 3,
  Addendum = 4,
  NoWas = 5,
  TradeReportCancel = 6,
  LockedInTradeBreak = 7,
  Defaulted = 8,
  InvalidCmta = 9,
  Pended = 10,
  AllegedNew = 11,
  AllegedAddendum = 12,
  AllegedNoWas = 13,
  AllegedTradeReportCancel = 14,
  Alleged2 = 15
}

export enum AllocNoOrdersType {
  NotSpecified = 0,
  ExplicitListProvided = 1
}

export enum EventType {
  Put = 1,
  Call = 2,
  Tender = 3,
  SinkingFundCall = 4,
  Activation = 5,
  Inactiviation = 6,
  Other = 99
}

export enum InstrAttribType {
  Flat = 1,
  ZeroCoupon = 2,
  InterestBearing = 3,
  NoPeriodicPayments = 4,
  VariableRate = 5,
  LessFeeForPut = 6,
  SteppedCoupon = 7,
  CouponPeriod = 8,
  WhenAndIfIssued = 9,
  OriginalIssueDiscount = 10,
  CallablePuttable = 11,
  EscrowedToMaturity = 12,
  EscrowedToRedemptionDate = 13,
  PreRefunded = 14,
  InDefault = 15,
  Unrated = 16,
  Taxable = 17,
  Indexed = 18,
  SubjectToAlternativeMinimumTax = 19,
  OriginalIssueDiscountPriceSupplyPriceInTheInstrattribvalue = 20,
  CallableBelowMaturityValue = 21,
  CallableWithoutNoticeByMailToHolderUnlessRegistered = 22,
  TextSupplyTheTextOfTheAttributeOrDisclaimerInTheInstrattribvalue = 99
}

export enum CPProgram {
  E3A = 1,
  E42 = 2,
  Other = 99
}

export enum MiscFeeBasis {
  Absolute = 0,
  PerUnit = 1,
  Percentage = 2
}

export enum CollAsgnReason {
  Initial = 0,
  Scheduled = 1,
  TimeWarning = 2,
  MarginDeficiency = 3,
  MarginExcess = 4,
  ForwardCollateralDemand = 5,
  EventOfDefault = 6,
  AdverseTaxEvent = 7
}

export enum CollInquiryQualifier {
  Tradedate = 0,
  GcInstrument = 1,
  Collateralinstrument = 2,
  SubstitutionEligible = 3,
  NotAssigned = 4,
  PartiallyAssigned = 5,
  FullyAssigned = 6,
  OutstandingTrades = 7
}

export enum CollAsgnTransType {
  New = 0,
  Replace = 1,
  Cancel = 2,
  Release = 3,
  Reverse = 4
}

export enum CollAsgnRespType {
  Received = 0,
  Accepted = 1,
  Declined = 2,
  Rejected = 3
}

export enum CollAsgnRejectReason {
  UnknownDeal = 0,
  UnknownOrInvalidInstrument = 1,
  UnauthorizedTransaction = 2,
  InsufficientCollateral = 3,
  InvalidTypeOfCollateral = 4,
  ExcessiveSubstitution = 5,
  Other = 99
}

export enum CollStatus {
  Unassigned = 0,
  PartiallyAssigned = 1,
  AssignmentProposed = 2,
  Assigned = 3,
  Challenged = 4
}

export enum DeliveryType {
  VersusPayment = 0,
  Free = 1,
  TriParty = 2,
  HoldInCustody = 3
}

export enum UserRequestType {
  Logonuser = 1,
  Logoffuser = 2,
  Changepasswordforuser = 3,
  RequestIndividualUserStatus = 4
}

export enum UserStatus {
  LoggedIn = 1,
  NotLoggedIn = 2,
  UserNotRecognised = 3,
  PasswordIncorrect = 4,
  PasswordChanged = 5,
  Other = 6
}

export enum StatusValue {
  Connected = 1,
  NotConnectedDownExpectedUp = 2,
  NotConnectedDownExpectedDown = 3,
  InProcess = 4
}

export enum NetworkRequestType {
  Snapshot = 1,
  Subscribe = 2,
  StopSubscribing = 4,
  LevelOfDetail = 8
}

export enum NetworkStatusResponseType {
  Full = 1,
  IncrementalUpdate = 2
}

export enum TrdRptStatus {
  Accepted = 0,
  Rejected = 1,
  AcceptedWithErrors = 3
}

export enum AffirmStatus {
  Received = 1,
  ConfirmRejected = 2,
  Affirmed = 3
}

export enum CollAction {
  Retain = 0,
  Add = 1,
  Remove = 2
}

export enum CollInquiryStatus {
  Accepted = 0,
  AcceptedWithWarnings = 1,
  Completed = 2,
  CompletedWithWarnings = 3,
  Rejected = 4
}

export enum CollInquiryResult {
  Successful = 0,
  InvalidOrUnknownInstrument = 1,
  InvalidOrUnknownCollateralType = 2,
  InvalidParties = 3,
  InvalidTransportTypeRequested = 4,
  InvalidDestinationRequested = 5,
  NoCollateralFoundForTheTradeSpecified = 6,
  NoCollateralFoundForTheOrderSpecified = 7,
  CollateralInquiryTypeNotSupported = 8,
  UnauthorizedForCollateralInquiry = 9,
  Other = 99
}

export enum StrategyParameterType {
  Int = 1,
  Length = 2,
  Numingroup = 3,
  Seqnum = 4,
  Tagnum = 5,
  Float = 6,
  Qty = 7,
  Price = 8,
  Priceoffset = 9,
  Amt = 10,
  Percentage = 11,
  Char = 12,
  Boolean = 13,
  String = 14,
  Multiplecharvalue = 15,
  Currency = 16,
  Exchange = 17,
  MonthYear = 18,
  Utctimestamp = 19,
  Utctimeonly = 20,
  Localmkttime = 21,
  Utcdate = 22,
  Data = 23,
  Multiplestringvalue = 24
}

export enum SecurityStatus {
  All = '0',
  Active = '1',
  Inactive = '2'
}

export enum UnderlyingCashType {
  Fixed = 'FIXED',
  Diff = 'DIFF'
}

export enum UnderlyingSettlementType {
  Tp1 = 2,
  Tp3 = 4,
  Tp4 = 5
}

export enum SecurityUpdateAction {
  Add = 'A',
  Delete = 'D',
  Modify = 'M'
}

export enum ExpType {
  AutoExercise = 1,
  NonAutoExercise = 2,
  FinalWillBeExercised = 3,
  ContraryIntention = 4,
  Difference = 5
}

export enum IndividualAllocType {
  SubAllocate = 1,
  ThirdPartyAllocation = 2
}

export enum UnitofMeasure {
  MegawattHours = 'MWh',
  OneMillionBtu = 'MMBtu',
  Barrels = 'Bbl',
  Gallons = 'Gal',
  MetricTons = 't',
  Tons = 'tn',
  MillionBarrels = 'MMbbl',
  Pounds = 'lbs',
  TroyOunces = 'oz_tr',
  UsDollars = 'USD',
  BillionCubicFeet = 'Bcf',
  Bushels = 'Bu'
}

export enum TimeUnit {
  Second = 'S',
  Minute = 'Min',
  Hour = 'H',
  Day = 'D',
  Week = 'Wk',
  Month = 'Mo',
  Year = 'Yr'
}

export enum AllocMethod {
  Automatic = 1,
  Guarantor = 2,
  Manual = 3
}

export enum SideTrdSubTyp {
  Cmta = 0,
  InternalTransfer = 1,
  ExternalTransfer = 2,
  RejectForSubmittingTrade = 3,
  AdvisoryForContraSide = 4,
  OffsetDueToAnAllocation = 5,
  OnsetDueToAnAllocation = 6,
  DifferentialSpread = 7,
  ImpliedSpreadLegExecutedAgainstAnOutright = 8,
  TransactionFromExercise = 9,
  TransactionFromAssignment = 10
}

export enum AsOfIndicator {
  False = '0',
  True = '1'
}

export enum MDBookType {
  TopOfBook = 1,
  PriceDepth = 2,
  OrderDepth = 3
}

export enum MDOriginType {
  Book = 0,
  OffBook = 1,
  Cross = 2
}

export enum CustOrderHandlingInst {
  AddOnOrder = 'ADD',
  AllOrNone = 'AON',
  CashNotHeld = 'CNH',
  DirectedOrder = 'DIR',
  ExchangeForPhysicalTransaction = 'E.W',
  FillOrKill = 'FOK',
  ImbalanceOnly = 'IO',
  ImmediateOrCancel = 'IOC',
  LimitOnOpen = 'LOO',
  LimitOnClose = 'LOC',
  MarketAtOpen = 'MAO',
  MarketAtClose = 'MAC',
  MarketOnOpen = 'MOO',
  MarketOnClose = 'MOC',
  MinimumQuantity = 'MQT',
  NotHeld = 'NH',
  OverTheDay = 'OVD',
  Pegged = 'PEG',
  ReserveSizeOrder = 'RSV',
  StopStockTransaction = 'S.W',
  Scale = 'SCL',
  TimeOrder = 'TMO',
  TrailingStop = 'TS',
  Work = 'WRK'
}

export enum OrderHandlingInstSource {
  NasdOats = 1
}

export enum DeskType {
  Agency = 'A',
  Arbitrage = 'AR',
  Derivatives = 'D',
  International = 'IN',
  Institutional = 'IS',
  Other = 'O',
  PreferredTrading = 'PF',
  Proprietary = 'PR',
  ProgramTrading = 'PT',
  Sales = 'S',
  Trading = 'T'
}

export enum DeskTypeSource {
  NasdOats = 1
}

export enum DeskOrderHandlingInst {
  AddOnOrder = 'ADD',
  AllOrNone = 'AON',
  CashNotHeld = 'CNH',
  DirectedOrder = 'DIR',
  ExchangeForPhysicalTransaction = 'E.W',
  FillOrKill = 'FOK',
  ImbalanceOnly = 'IO',
  ImmediateOrCancel = 'IOC',
  LimitOnOpen = 'LOO',
  LimitOnClose = 'LOC',
  MarketAtOpen = 'MAO',
  MarketAtClose = 'MAC',
  MarketOnOpen = 'MOO',
  MarketOnClose = 'MOC',
  MinimumQuantity = 'MQT',
  NotHeld = 'NH',
  OverTheDay = 'OVD',
  Pegged = 'PEG',
  ReserveSizeOrder = 'RSV',
  StopStockTransaction = 'S.W',
  Scale = 'SCL',
  TimeOrder = 'TMO',
  TrailingStop = 'TS',
  Work = 'WRK'
}

export enum ExecAckStatus {
  ReceivedNotYetProcessed = '0',
  Accepted = '1',
  DontKnow = '2'
}

export enum CollApplType {
  SpecificDeposit = 0,
  General = 1
}

export enum UnderlyingFXRateCalc {
  Multiply = 'M',
  Divide = 'D'
}

export enum AllocPositionEffect {
  Open = 'O',
  Close = 'C',
  Rolled = 'R',
  Fifo = 'F'
}

export enum MDQuoteType {
  Indicative = 0,
  Tradeable = 1,
  RestrictedTradeable = 2,
  Counter = 3,
  IndicativeAndTradeable = 4
}

export enum RefOrderIDSource {
  Secondaryordeid = '0',
  Ordeid = '1',
  Mentryid = '2',
  Quotentryid = '3'
}

export enum DisplayWhen {
  Immediate = '1',
  Exhaust = '2'
}

export enum DisplayMethod {
  Initial = '1',
  New = '2',
  Random = '3'
}

export enum PriceProtectionScope {
  None = '0',
  Local = '1',
  National = '2',
  Global = '3'
}

export enum LotType {
  OddLot = '1',
  RoundLot = '2',
  BlockLot = '3'
}

export enum PegPriceType {
  LastPeg = 1,
  MidPricePeg = 2,
  OpeningPeg = 3,
  MarketPeg = 4,
  PrimaryPeg = 5,
  FixedPegToLocalBestBidOrOfferAtTimeOfOrder = 6,
  PegToVwap = 7,
  TrailingStopPeg = 8,
  PegToLimitPrice = 9
}

export enum TriggerType {
  PartialExecution = '1',
  SpecifiedTradingSession = '2',
  NextAuction = '3',
  PriceMovement = '4'
}

export enum TriggerAction {
  Activate = '1',
  Modify = '2',
  Cancel = '3'
}

export enum TriggerPriceType {
  BestOffer = '1',
  LastTrade = '2',
  BestBid = '3',
  BestBidOrLastTrade = '4',
  BestOfferOrLastTrade = '5',
  BestMid = '6'
}

export enum TriggerPriceTypeScope {
  None = '0',
  Local = '1',
  National = '2',
  Global = '3'
}

export enum TriggerPriceDirection {
  TriggerIfThePriceOfTheSpecifiedTypeGoesUpToOrThroughTheSpecifiedTriggerPrice = 'U',
  TriggerIfThePriceOfTheSpecifiedTypeGoesDownToOrThroughTheSpecifiedTriggerPrice = 'D'
}

export enum TriggerOrderType {
  Market = '1',
  Limit = '2'
}

export enum OrderCategory {
  Order = '1',
  Quote = '2',
  PrivatelyNegotiatedTrade = '3',
  MultilegOrder = '4',
  LinkedOrder = '5',
  QuoteRequest = '6',
  ImpliedOrder = '7',
  CrossOrder = '8'
}

export enum TradeHandlingInstr {
  TradeConfirmation = '0',
  TwoPartyReport = '1',
  OnePartyReportForMatching = '2',
  OnePartyReportForPassThrough = '3',
  AutomatedFloorOrderRouting = '4'
}

export enum ApplVerID {
  Fix27 = '0',
  Fix30 = '1',
  Fix40 = '2',
  Fix41 = '3',
  Fix42 = '4',
  Fix43 = '5',
  Fix44 = '6',
  Fix50 = '7',
  Fix50Sp1 = '8',
  Fix50Sp2 = '9'
}

export enum ExDestinationIDSource {
  Bic = 'B',
  GenerallyAcceptedMarketParticipantIdentifier = 'C',
  Proprietary = 'D',
  IsoCountryCode = 'E',
  Mic = 'G'
}

export enum ImpliedMarketIndicator {
  NotImplied = 0,
  ImpliedIn = 1,
  ImpliedOut = 2,
  BothImpliedInAndImpliedOut = 3
}

export enum SettlObligMode {
  Preliminary = 1,
  Final = 2
}

export enum SettlObligTransType {
  Cancel = 'C',
  New = 'N',
  Replace = 'R',
  Restate = 'T'
}

export enum SettlObligSource {
  InstructionsOfBroker = '1',
  InstructionsForInstitution = '2',
  Investor = '3'
}

export enum QuoteEntryStatus {
  Accepted = 0,
  Rejected = 5,
  RemovedFromMarket = 6,
  Expired = 7,
  LockedMarketWarning = 12,
  CrossMarketWarning = 13,
  CanceledDueToLockMarket = 14,
  CanceledDueToCrossMarket = 15,
  Active = 16
}

export enum RespondentType {
  AllMarketParticipants = 1,
  SpecifiedMarketParticipants = 2,
  AllMarketMakers = 3,
  PrimaryMarketMaker = 4
}

export enum SecurityTradingEvent {
  OrderImbalanceAuctionIsExtended = 1,
  TradingResumes = 2,
  PriceVolatilityInterruption = 3,
  ChangeOfTradingSession = 4,
  ChangeOfTradingSubsession = 5,
  ChangeOfSecurityTradingStatus = 6,
  ChangeOfBookType = 7,
  ChangeOfMarketDepth = 8
}

export enum StatsType {
  ExchangeLast = 1,
  High = 2,
  AveragePrice = 3,
  Turnover = 4
}

export enum MDSecSizeType {
  Customer = 1
}

export enum SettlMethod {
  CashSettlementRequired = 'C',
  PhysicalSettlementRequired = 'P'
}

export enum ExerciseStyle {
  European = 0,
  American = 1,
  Bermuda = 2
}

export enum PriceQuoteMethod {
  Standard = 'STD',
  Index = 'INX',
  InterestRateIndex = 'INT',
  PercentOfPar = 'PCTPAR'
}

export enum ValuationMethod {
  PremiumStyle = 'EQTY',
  FuturesStyleMarkToMarket = 'FUT',
  FuturesStyleWithAnAttachedCashAdjustment = 'FUTDA',
  CdsStyleCollateralizationOfMarketToMarketAndCoupon = 'CDS',
  CdsInDelivery = 'CDSD'
}

export enum ListMethod {
  PreListedOnly = 0,
  UserRequested = 1
}

export enum TickRuleType {
  Regular = 0,
  Variable = 1,
  Fixed = 2,
  TradedAsASpreadLeg = 3,
  SettledAsASpreadLeg = 4
}

export enum MaturityMonthYearIncrementUnits {
  Months = 0,
  Days = 1,
  Weeks = 2,
  Years = 3
}

export enum MaturityMonthYearFormat {
  YearmonthOnly = 0,
  Yearmonthday = 1,
  Yearmonthweek = 2
}

export enum PriceLimitType {
  Price = 0,
  Ticks = 1,
  Percentage = 2
}

export enum DerivativeSecurityListRequestType {
  Symbol = 0,
  SecuritytypeAndOrCficode = 1,
  Product = 2,
  Tradingsessionid = 3,
  AllSecurities = 4,
  Undelyingsymbol = 5,
  UnderlyingSecuritytypeAndOrCficode = 6,
  UnderlyingProduct = 7,
  MarketidOrMarketidPlusMarketsegmentid = 8
}

export enum ApplReqType {
  RetransmissionOfApplicationMessagesForTheSpecifiedApplications = 0,
  SubscriptionToTheSpecifiedApplications = 1,
  RequestForTheLastAppllastseqnumPublishedForTheSpecifiedApplications = 2,
  RequestValidSetOfApplications = 3,
  UnsubscribeToTheSpecifiedApplications = 4,
  CancelRetransmission = 5,
  CancelRetransmissionAndUnsubscribeToTheSpecifiedApplications = 6
}

export enum ApplResponseType {
  RequestSuccessfullyProcessed = 0,
  ApplicationDoesNotExist = 1,
  MessagesNotAvailable = 2
}

export enum ApplResponseError {
  ApplicationDoesNotExist = 0,
  MessagesRequestedAreNotAvailable = 1,
  UserNotAuthorizedForApplication = 2
}

export enum TradSesEvent {
  TradingResumes = 0,
  ChangeOfTradingSession = 1,
  ChangeOfTradingSubsession = 2,
  ChangeOfTradingStatus = 3
}

export enum MassActionType {
  SuspendOrders = 1,
  ReleaseOrdersFromSuspension = 2,
  CancelOrders = 3
}

export enum MassActionScope {
  AllOrdersForASecurity = 1,
  AllOrdersForAnUnderlyingSecurity = 2,
  AllOrdersForAProduct = 3,
  AllOrdersForACficode = 4,
  AllOrdersForASecuritytype = 5,
  AllOrdersForATradingSession = 6,
  AllOrders = 7,
  AllOrdersForAMarket = 8,
  AllOrdersForAMarketSegment = 9,
  AllOrdersForASecurityGroup = 10,
  CancelForSecurityIssuer = 11,
  CancelForIssuerOfUnderlyingSecurity = 12
}

export enum MassActionResponse {
  Rejected = 0,
  Accepted = 1
}

export enum MassActionRejectReason {
  MassActionNotSupported = 0,
  InvalidOrUnknownSecurity = 1,
  InvalidOrUnknownUnderlyingSecurity = 2,
  InvalidOrUnknownProduct = 3,
  InvalidOrUnknownCficode = 4,
  InvalidOrUnknownSecuritytype = 5,
  InvalidOrUnknownTradingSession = 6,
  InvalidOrUnknownMarket = 7,
  InvalidOrUnknownMarketSegment = 8,
  InvalidOrUnknownSecurityGroup = 9,
  InvalidOrUnknownSecurityIssuer = 10,
  InvalidOrUnknownIssuerOfUnderlyingSecurity = 11,
  Other = 99
}

export enum MultilegModel {
  PredefinedMultilegSecurity = 0,
  UserDefinedMultlegSecurity = 1,
  UserDefinedNonSecuritizedMultileg = 2
}

export enum MultilegPriceMethod {
  NetPrice = 0,
  ReversedNetPrice = 1,
  YieldDifference = 2,
  Individual = 3,
  ContractWeightedAveragePrice = 4,
  MultipliedPrice = 5
}

export enum ContingencyType {
  OneCancelsTheOther = 1,
  OneTriggersTheOther = 2,
  OneUpdatesTheOther3 = 3,
  OneUpdatesTheOther4 = 4
}

export enum ListRejectReason {
  Broker = 0,
  ExchangeClosed = 2,
  TooLateToEnter = 4,
  UnknownOrder = 5,
  DuplicateOrder = 6,
  UnsupportedOrderCharacteristic = 11,
  Other = 99
}

export enum TradePublishIndicator {
  DoNotPublishTrade = 0,
  PublishTrade = 1,
  DeferredPublication = 2
}

export enum MarketUpdateAction {
  Add = 'A',
  Delete = 'D',
  Modify = 'M'
}

export enum SessionStatus {
  SessionActive = 0,
  SessionPasswordChanged = 1,
  SessionPasswordDueToExpire = 2,
  NewSessionPasswordDoesNotComplyWithPolicy = 3,
  SessionLogoutComplete = 4,
  InvalidUsernameOrPassword = 5,
  AccountLocked = 6,
  LogonsAreNotAllowedAtThisTime = 7,
  PasswordExpired = 8
}

export enum ApplReportType {
  ResetApplseqnumToNewValueSpecifiedInApplnewseqnum = 0,
  ReportsThatTheLastMessageHasBeenSentForTheApplidsReferToRefappllastseqnum = 1,
  HeartbeatMessageIndicatingThatApplicationIdentifiedByRefapplid = 2,
  ApplicationMessageReSendCompleted = 3
}

export enum OrderDelayUnit {
  Seconds = 0,
  TenthsOfASecond = 1,
  HundredthsOfASecond = 2,
  Milliseconds = 3,
  Microseconds = 4,
  Nanoseconds = 5,
  Minutes = 10,
  Hours = 11,
  Days = 12,
  Weeks = 13,
  Months = 14,
  Years = 15
}

export enum VenueType {
  Electronic = 'E',
  Pit = 'P',
  ExPit = 'X'
}

export enum RefOrdIDReason {
  GtcFromPreviousDay = 0,
  PartialFillRemaining = 1,
  OrderChanged = 2
}

export enum OrigCustOrderCapacity {
  MemberTradingForTheirOwnAccount = 1,
  ClearingFirmTradingForItsProprietaryAccount = 2,
  MemberTradingForAnotherMember = 3,
  AllOther = 4
}

export enum ModelType {
  UtilityProvidedStandardModel = 0,
  Proprietary = 1
}

export enum ContractMultiplierUnit {
  Shares = 0,
  Hours = 1,
  Days = 2
}

export enum FlowScheduleType {
  NercEasternOffPeak = 0,
  NercWesternOffPeak = 1,
  NercCalendarAllDaysInMonth = 2,
  NercEasternPeak = 3,
  NercWesternPeak = 4
}

export enum RateSource {
  Bloomberg = 0,
  Reuters = 1,
  Telerate = 2,
  Other = 99
}

export enum RateSourceType {
  Primary = 0,
  Secondary = 1
}

export enum RestructuringType {
  FullRestructuring = 'FR',
  ModifiedRestructuring = 'MR',
  ModifiedModRestructuring = 'MM',
  NoRestructuringSpecified = 'XR'
}

export enum Seniority {
  SeniorSecured = 'SD',
  Senior = 'SR',
  Subordinated = 'SB'
}

export enum SecurityListType {
  IndustryClassification = 1,
  TradingList = 2,
  Market = 3,
  NewspaperList = 4
}

export enum SecurityListTypeSource {
  Icb = 1,
  Naics = 2,
  Gics = 3
}

export enum NewsCategory {
  CompanyNews = 0,
  MarketplaceNews = 1,
  FinancialMarketNews = 2,
  TechnicalNews = 3,
  OtherNews = 99
}

export enum NewsRefType {
  Replacement = 0,
  OtherLanguage = 1,
  Complimentary = 2
}

export enum StrikePriceDeterminationMethod {
  FixedStrike = 1,
  StrikeSetAtExpirationToUnderlyingOrOtherValue = 2,
  StrikeSetToAverageOfUnderlyingSettlementPriceAcrossTheLifeOfTheOption = 3,
  StrikeSetToOptimalValue = 4
}

export enum StrikePriceBoundaryMethod {
  LessThanUnderlyingPriceIsInTheMoney = 1,
  LessThanOrEqualToTheUnderlyingPriceIsInTheMoney = 2,
  EqualToTheUnderlyingPriceIsInTheMoney = 3,
  GreaterThanOrEqualToUnderlyingPriceIsInTheMoney = 4,
  GreaterThanUnderlyingIsInTheMoney = 5
}

export enum UnderlyingPriceDeterminationMethod {
  Regular = 1,
  SpecialReference = 2,
  OptimalValue = 3,
  AverageValue = 4
}

export enum OptPayoutType {
  Vanilla = 1,
  Capped = 2,
  Binary = 3
}

export enum ComplexEventType {
  Capped = 1,
  Trigger = 2,
  KnockInUp = 3,
  KockInDown = 4,
  KnockOutUp = 5,
  KnockOutDown = 6,
  Underlying = 7,
  ResetBarrier = 8,
  RollingBarrier = 9
}

export enum ComplexEventPriceBoundaryMethod {
  LessThanComplexeventprice = 1,
  LessThanOrEqualToComplexeventprice = 2,
  EqualToComplexeventprice = 3,
  GreaterThanOrEqualToComplexeventprice = 4,
  GreaterThanComplexeventprice = 5
}

export enum ComplexEventPriceTimeType {
  Expiration = 1,
  Immediate = 2,
  SpecifiedDateTime = 3
}

export enum ComplexEventCondition {
  And = 1,
  Or = 2
}

export enum StreamAsgnReqType {
  StreamAssignmentForNewCustomer = 1,
  StreamAssignmentForExistingCustomer = 2
}

export enum StreamAsgnRejReason {
  UnknownClient = 0,
  ExceedsMaximumSize = 1,
  UnknownOrInvalidCurrencyPair = 2,
  NoAvailableStream = 3,
  Other = 99
}

export enum StreamAsgnAckType {
  AssignmentAccepted = 0,
  AssignmentRejected = 1
}

export enum PartyListResponseType {
  ReturnAllAvailableInformationOnPartiesAndRelatedParties = 0,
  ReturnOnlyPartyInformation = 1,
  IncludeInformationOnRelatedParties = 2,
  IncludeRiskLimitInformation = 3
}

export enum PartyDetailsRequestResult {
  ValidRequest = 0,
  InvalidOrUnsupportedRequest = 1,
  NoPartiesOrPartyDetailsFoundThatMatchSelectionCriteria = 2,
  UnsupportedPartylistresponsetype = 3,
  NotAuthorizedToRetrievePartiesOrPartyDetailsData = 4,
  PartiesOrPartyDetailsDataTemporarilyUnavailable = 5,
  RequestForPartiesDataNotSupported = 6,
  Other = 99
}

export enum PartyRelationship {
  IsAlso = 0,
  ClearsFor = 1,
  ClearsThrough = 2,
  TradesFor = 3,
  TradesThrough = 4,
  Sponsors = 5,
  SponsoredThrough = 6,
  ProvidesGuaranteeFor = 7,
  IsGuaranteedBy = 8,
  MemberOf = 9,
  HasMembers = 10,
  ProvidesMarketplaceFor = 11,
  ParticipantOfMarketplace = 12,
  CarriesPositionsFor = 13,
  PostsTradesTo = 14,
  EntersTradesFor = 15,
  EntersTradesThrough = 16,
  ProvidesQuotesTo = 17,
  RequestsQuotesFrom = 18,
  InvestsFor = 19,
  InvestsThrough = 20,
  BrokersTradesFor = 21,
  BrokersTradesThrough = 22,
  ProvidesTradingServicesFor = 23,
  UsesTradingServicesOf = 24,
  ApprovesOf = 25,
  ApprovedBy = 26,
  ParentFirmFor = 27,
  SubsidiaryOf = 28,
  RegulatoryOwnerOf = 29,
  OwnedBy30 = 30,
  Controls = 31,
  IsControlledBy = 32,
  Legal = 33,
  OwnedBy34 = 34,
  BeneficialOwnerOf = 35,
  OwnedBy36 = 36
}

export enum RiskLimitType {
  GrossLimit = 1,
  NetLimit = 2,
  Exposure = 3,
  LongLimit = 4,
  ShortLimit = 5
}

export enum RiskInstrumentOperator {
  Include = 1,
  Exclude = 2
}

export enum StreamAsgnType {
  Assignment = 1,
  Rejected = 2,
  TerminateUnassign = 3
}

export enum MDElementName {
  BestBid = 1,
  BestOffer = 2,
  Paid = 11,
  Given = 12,
  DealableBid = 45,
  DealableOffer = 46,
  LocalBid = 47,
  LocalOffer = 48,
  DealableRegularBid = 49,
  DealableRegularOffer = 50,
  DealableOutsideBid = 51,
  DealableOutsideOffer = 52,
  DealablePlusBid = 53,
  DealablePlusOffer = 54
}

export enum AccountListRequestType {
  Account = 0,
  AccountType = 1,
  AllAccount = 2
}

export enum AccountRequestResult {
  ValidRequest = 0,
  InvalidOrUnsupportedRequest = 1,
  NoAccountFoundThatMatchSelectionCriteria = 2,
  NotAuthorizedToRetrieveAccountData = 3,
  AccountDataTemporarilyUnavailable = 4,
  RequestForAccountDataNotSupported = 5
}

export enum MarketDataType {
  Detailed = 'D',
  Plain = 'P'
}

export enum RofexProps {
  TodoONada = 'T',
  Pase = 'P'
}

export enum TradeSide {
  Buy = '1',
  Sell = '2'
}

