import { IStandardHeader } from './set/standard_header'
import { IMsgTypeGrp } from './set/msg_type_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface ILogon {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  Text?: string// [2] 58 (String)
  EncryptMethod: number// [3] 98 (Int)
  HeartBtInt: number// [4] 108 (Int)
  RawDataLength?: number// [5] 95 (Length)
  RawData?: Buffer// [6] 96 (RawData)
  ResetSeqNumFlag?: boolean// [7] 141 (Boolean)
  NextExpectedMsgSeqNum?: number// [8] 789 (Int)
  MaxMessageSize?: number// [9] 383 (Length)
  TestMessageIndicator?: boolean// [10] 464 (Boolean)
  Username?: string// [11] 553 (String)
  Password?: string// [12] 554 (String)
  OTP?: string// [13] 20000 (String)
  DefaultApplVerID: string// [14] 1137 (String)
  MsgTypeGrp?: IMsgTypeGrp// [15] NoMsgTypes.384, RefMsgType.372 .. RefCstmApplVerID.1131
  StandardTrailer: IStandardTrailer// [16] SignatureLength.93, Signature.89, CheckSum.10
}
