import { IStandardHeader } from './set/standard_header'
import { IInstrument } from './set/instrument'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { IInstrmtLegGrp } from './set/instrmt_leg_grp'
import { IMDFullGrp } from './set/md_full_grp'
import { IRoutingGrp } from './set/routing_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface IMarketDataSnapshotFullRefresh {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  MDReqID?: string// [2] 262 (String)
  Instrument?: IInstrument// [3] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  UndInstrmtGrp?: IUndInstrmtGrp// [4] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  InstrmtLegGrp?: IInstrmtLegGrp// [5] NoLegs.555, LegSymbol.600 .. LegTimeUnit.1001
  FinancialStatus?: string// [6] 291 (String)
  CorporateAction?: string// [7] 292 (String)
  NetChgPrevDay?: number// [8] 451 (Float)
  MDFullGrp?: IMDFullGrp// [9] NoMDEntries.268, MDEntryType.269 .. MDEntrySizes.7202
  ApplQueueDepth?: number// [10] 813 (Int)
  ApplQueueResolution?: number// [11] 814 (Int)
  MDReportID?: number// [12] 963 (Int)
  ClearingBusinessDate?: Date// [13] 715 (LocalDate)
  MDBookType?: number// [14] 1021 (Int)
  MDFeedType?: string// [15] 1022 (String)
  TradeDate?: Date// [16] 75 (LocalDate)
  MarketDepth?: number// [17] 264 (Int)
  RoutingGrp?: IRoutingGrp// [18] NoRoutingIDs.215, RoutingType.216, RoutingID.217
  StandardTrailer: IStandardTrailer// [19] SignatureLength.93, Signature.89, CheckSum.10
}
