import { IStandardHeader } from './set/standard_header'
import { IRoutingGrp } from './set/routing_grp'
import { IInstrmtGrp } from './set/instrmt_grp'
import { IInstrmtLegGrp } from './set/instrmt_leg_grp'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { ILinesOfTextGrp } from './set/lines_of_text_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface INews {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  OrigTime?: Date// [2] 42 (UtcTimestamp)
  Urgency?: string// [3] 61 (String)
  MarketSegmentID?: string// [4] 1300 (String)
  Headline: string// [5] 148 (String)
  EncodedHeadlineLen?: number// [6] 358 (Length)
  EncodedHeadline?: Buffer// [7] 359 (RawData)
  RoutingGrp?: IRoutingGrp// [8] NoRoutingIDs.215, RoutingType.216, RoutingID.217
  InstrmtGrp?: IInstrmtGrp// [9] NoRelatedSym.146, Symbol.55 .. TradingDeadline.5517
  InstrmtLegGrp?: IInstrmtLegGrp// [10] NoLegs.555, LegSymbol.600 .. LegTimeUnit.1001
  UndInstrmtGrp?: IUndInstrmtGrp// [11] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  LinesOfTextGrp?: ILinesOfTextGrp// [12] NoLinesOfText.33, Text.58 .. EncodedText.355
  URLLink?: string// [13] 149 (String)
  RawDataLength?: number// [14] 95 (Length)
  RawData?: Buffer// [15] 96 (RawData)
  StandardTrailer: IStandardTrailer// [16] SignatureLength.93, Signature.89, CheckSum.10
}
