import { IStandardHeader } from './set/standard_header'
import { IAffectedOrdGrp } from './set/affected_ord_grp'
import { IInstrument } from './set/instrument'
import { IUnderlyingInstrument } from './set/underlying_instrument'
import { IParties } from './set/parties'
import { IStandardTrailer } from './set/standard_trailer'

export interface IOrderMassCancelReport {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  ClOrdID?: string// [2] 11 (String)
  SecondaryClOrdID?: string// [3] 526 (String)
  OrderID: string// [4] 37 (String)
  MassActionReportID: string// [5] 1369 (String)
  SecondaryOrderID?: string// [6] 198 (String)
  MassCancelRequestType: string// [7] 530 (String)
  MassCancelResponse: string// [8] 531 (String)
  MassCancelRejectReason?: number// [9] 532 (Int)
  TotalAffectedOrders?: number// [10] 533 (Int)
  AffectedOrdGrp?: IAffectedOrdGrp// [11] NoAffectedOrders.534
  TradingSessionID?: string// [12] 336 (String)
  TradingSessionSubID?: string// [13] 625 (String)
  Instrument?: IInstrument// [14] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  UnderlyingInstrument?: IUnderlyingInstrument// [15] UnderlyingSymbol.311, UnderlyingSymbolSfx.312 .. UnderlyingFXRateCalc.1046
  Side?: string// [16] 54 (String)
  TransactTime?: Date// [17] 60 (UtcTimestamp)
  Text?: string// [18] 58 (String)
  EncodedTextLen?: number// [19] 354 (Length)
  EncodedText?: Buffer// [20] 355 (RawData)
  Parties?: IParties// [21] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  StandardTrailer: IStandardTrailer// [22] SignatureLength.93, Signature.89, CheckSum.10
}
