import { IStandardHeader } from './set/standard_header'
import { IInstrument } from './set/instrument'
import { IUnderlyingInstrument } from './set/underlying_instrument'
import { IParties } from './set/parties'
import { IStandardTrailer } from './set/standard_trailer'

export interface IOrderMassCancelRequest {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  ClOrdID: string// [2] 11 (String)
  SecondaryClOrdID?: string// [3] 526 (String)
  MassCancelRequestType: string// [4] 530 (String)
  Account?: string// [5] 1 (String)
  AcctIDSource?: number// [6] 660 (Int)
  TradingSessionID?: string// [7] 336 (String)
  TradingSessionSubID?: string// [8] 625 (String)
  Instrument?: IInstrument// [9] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  UnderlyingInstrument?: IUnderlyingInstrument// [10] UnderlyingSymbol.311, UnderlyingSymbolSfx.312 .. UnderlyingFXRateCalc.1046
  Side?: string// [11] 54 (String)
  TransactTime: Date// [12] 60 (UtcTimestamp)
  Text?: string// [13] 58 (String)
  EncodedTextLen?: number// [14] 354 (Length)
  EncodedText?: Buffer// [15] 355 (RawData)
  Parties?: IParties// [16] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  MarketID?: string// [17] 1301 (String)
  MarketSegmentID?: string// [18] 1300 (String)
  StandardTrailer: IStandardTrailer// [19] SignatureLength.93, Signature.89, CheckSum.10
}
