import { IStandardHeader } from './set/standard_header'
import { IQuotReqGrp } from './set/quot_req_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface IQuoteRequest {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  QuoteReqID: string// [2] 131 (String)
  QuoteReqServerID?: string// [3] 7124 (String)
  RFQReqID?: string// [4] 644 (String)
  ClOrdID?: string// [5] 11 (String)
  OrderCapacity?: string// [6] 528 (String)
  QuotReqGrp?: IQuotReqGrp// [7] NoRelatedSym.146, Symbol.55 .. PartySubIDType.803
  Text?: string// [8] 58 (String)
  EncodedTextLen?: number// [9] 354 (Length)
  EncodedText?: Buffer// [10] 355 (RawData)
  StandardTrailer: IStandardTrailer// [11] SignatureLength.93, Signature.89, CheckSum.10
}
