import { IStandardHeader } from './set/standard_header'
import { IQuotQualGrp } from './set/quot_qual_grp'
import { IParties } from './set/parties'
import { IInstrument } from './set/instrument'
import { IFinancingDetails } from './set/financing_details'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { IOrderQtyData } from './set/order_qty_data'
import { IStipulations } from './set/stipulations'
import { ILegQuotGrp } from './set/leg_quot_grp'
import { ISpreadOrBenchmarkCurveData } from './set/spread_or_benchmark_curve_data'
import { IYieldData } from './set/yield_data'
import { IStandardTrailer } from './set/standard_trailer'

export interface IQuoteResponse {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  QuoteRespID: string// [2] 693 (String)
  QuoteID?: string// [3] 117 (String)
  QuoteMsgID?: string// [4] 1166 (String)
  QuoteRespType: number// [5] 694 (Int)
  ClOrdID?: string// [6] 11 (String)
  OrderCapacity?: string// [7] 528 (String)
  IOIid?: string// [8] 23 (String)
  QuoteType?: number// [9] 537 (Int)
  QuotQualGrp?: IQuotQualGrp// [10] NoQuoteQualifiers.735, QuoteQualifier.695
  Parties?: IParties// [11] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  TradingSessionID?: string// [12] 336 (String)
  TradingSessionSubID?: string// [13] 625 (String)
  Instrument?: IInstrument// [14] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  FinancingDetails?: IFinancingDetails// [15] AgreementDesc.913, AgreementID.914 .. MarginRatio.898
  UndInstrmtGrp?: IUndInstrmtGrp// [16] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  Side?: string// [17] 54 (String)
  OrderQtyData?: IOrderQtyData// [18] OrderQty.38, CashOrderQty.152 .. RoundingModulus.469
  SettlType?: string// [19] 63 (String)
  SettlDate?: Date// [20] 64 (LocalDate)
  SettlDate2?: Date// [21] 193 (LocalDate)
  OrderQty2?: number// [22] 192 (Float)
  Currency?: string// [23] 15 (String)
  Stipulations?: IStipulations// [24] NoStipulations.232, StipulationType.233, StipulationValue.234
  Account?: string// [25] 1 (String)
  AcctIDSource?: number// [26] 660 (Int)
  AccountType?: number// [27] 581 (Int)
  LegQuotGrp?: ILegQuotGrp// [28] NoLegs.555, LegSymbol.600 .. LegOfferForwardPoints.1068
  BidPx?: number// [29] 132 (Float)
  OfferPx?: number// [30] 133 (Float)
  MktBidPx?: number// [31] 645 (Float)
  MktOfferPx?: number// [32] 646 (Float)
  MinBidSize?: number// [33] 647 (Float)
  BidSize?: number// [34] 134 (Float)
  MinOfferSize?: number// [35] 648 (Float)
  OfferSize?: number// [36] 135 (Float)
  ValidUntilTime?: Date// [37] 62 (UtcTimestamp)
  BidSpotRate?: number// [38] 188 (Float)
  OfferSpotRate?: number// [39] 190 (Float)
  BidForwardPoints?: number// [40] 189 (Float)
  OfferForwardPoints?: number// [41] 191 (Float)
  MidPx?: number// [42] 631 (Float)
  BidYield?: number// [43] 632 (Float)
  MidYield?: number// [44] 633 (Float)
  OfferYield?: number// [45] 634 (Float)
  TransactTime?: Date// [46] 60 (UtcTimestamp)
  OrdType?: string// [47] 40 (String)
  BidForwardPoints2?: number// [48] 642 (Float)
  OfferForwardPoints2?: number// [49] 643 (Float)
  SettlCurrBidFxRate?: number// [50] 656 (Float)
  SettlCurrOfferFxRate?: number// [51] 657 (Float)
  SettlCurrFxRateCalc?: string// [52] 156 (String)
  Commission?: number// [53] 12 (Float)
  CommType?: string// [54] 13 (String)
  CustOrderCapacity?: number// [55] 582 (Int)
  ExDestination?: string// [56] 100 (String)
  Text?: string// [57] 58 (String)
  EncodedTextLen?: number// [58] 354 (Length)
  EncodedText?: Buffer// [59] 355 (RawData)
  Price?: number// [60] 44 (Float)
  PriceType?: number// [61] 423 (Int)
  SpreadOrBenchmarkCurveData?: ISpreadOrBenchmarkCurveData// [62] Spread.218, BenchmarkCurveCurrency.220 .. BenchmarkSecurityIDSource.761
  YieldData?: IYieldData// [63] YieldType.235, Yield.236 .. YieldRedemptionPriceType.698
  ExDestinationIDSource?: string// [64] 1133 (String)
  StandardTrailer: IStandardTrailer// [65] SignatureLength.93, Signature.89, CheckSum.10
}
