import { IStandardHeader } from './set/standard_header'
import { IParties } from './set/parties'
import { IInstrument } from './set/instrument'
import { IInstrmtLegGrp } from './set/instrmt_leg_grp'
import { IUndInstrmtGrp } from './set/und_instrmt_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface IRequestForPositionsAck {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  PosMaintRptID: string// [2] 721 (String)
  PosReqID?: string// [3] 710 (String)
  TotalNumPosReports?: number// [4] 727 (Int)
  UnsolicitedIndicator?: boolean// [5] 325 (Boolean)
  PosReqResult: number// [6] 728 (Int)
  PosReqStatus: number// [7] 729 (Int)
  Parties?: IParties// [8] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  Account?: string// [9] 1 (String)
  AcctIDSource?: number// [10] 660 (Int)
  AccountType?: number// [11] 581 (Int)
  Instrument?: IInstrument// [12] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  Currency?: string// [13] 15 (String)
  InstrmtLegGrp?: IInstrmtLegGrp// [14] NoLegs.555, LegSymbol.600 .. LegTimeUnit.1001
  UndInstrmtGrp?: IUndInstrmtGrp// [15] NoUnderlyings.711, UnderlyingSymbol.311 .. UnderlyingFXRateCalc.1046
  ResponseTransportType?: number// [16] 725 (Int)
  ResponseDestination?: string// [17] 726 (String)
  Text?: string// [18] 58 (String)
  EncodedTextLen?: number// [19] 354 (Length)
  EncodedText?: Buffer// [20] 355 (RawData)
  PosReqType?: number// [21] 724 (Int)
  MatchStatus?: string// [22] 573 (String)
  ClearingBusinessDate?: Date// [23] 715 (LocalDate)
  SubscriptionRequestType?: string// [24] 263 (String)
  SettlSessID?: string// [25] 716 (String)
  SettlSessSubID?: string// [26] 717 (String)
  SettlCurrency?: string// [27] 120 (String)
  StandardTrailer: IStandardTrailer// [28] SignatureLength.93, Signature.89, CheckSum.10
}
