import { IStandardHeader } from './set/standard_header'
import { IInstrument } from './set/instrument'
import { IUnderlyingInstrument } from './set/underlying_instrument'
import { IInstrmtLegGrp } from './set/instrmt_leg_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface ISecurityDefinitionUpdateReport {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  SecurityReportID?: number// [2] 964 (Int)
  SecurityReqID?: string// [3] 320 (String)
  SecurityResponseID?: string// [4] 322 (String)
  SecurityResponseType?: number// [5] 323 (Int)
  ClearingBusinessDate?: Date// [6] 715 (LocalDate)
  SecurityUpdateAction?: string// [7] 980 (String)
  CorporateAction?: string// [8] 292 (String)
  Instrument?: IInstrument// [9] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  UnderlyingInstrument?: IUnderlyingInstrument// [10] UnderlyingSymbol.311, UnderlyingSymbolSfx.312 .. UnderlyingFXRateCalc.1046
  Currency?: string// [11] 15 (String)
  TradingSessionID?: string// [12] 336 (String)
  TradingSessionSubID?: string// [13] 625 (String)
  Text?: string// [14] 58 (String)
  EncodedTextLen?: number// [15] 354 (Length)
  EncodedText?: Buffer// [16] 355 (RawData)
  InstrmtLegGrp?: IInstrmtLegGrp// [17] NoLegs.555, LegSymbol.600 .. LegTimeUnit.1001
  ExpirationCycle?: number// [18] 827 (Int)
  RoundLot?: number// [19] 561 (Float)
  MinTradeVol?: number// [20] 562 (Float)
  StandardTrailer: IStandardTrailer// [21] SignatureLength.93, Signature.89, CheckSum.10
}
