import { IStandardHeader } from './set/standard_header'
import { ISecListGrp } from './set/sec_list_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface ISecurityList {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  SecurityReqID?: string// [2] 320 (String)
  SecurityResponseID?: string// [3] 322 (String)
  SecurityRequestResult?: number// [4] 560 (Int)
  SecurityListRequestType?: number// [5] 559 (Int)
  TotNoRelatedSym?: number// [6] 393 (Int)
  LastFragment?: boolean// [7] 893 (Boolean)
  SecListGrp?: ISecListGrp// [8] NoRelatedSym.146, Symbol.55 .. RelSymTransactTime.1504
  SecurityReportID?: number// [9] 964 (Int)
  ClearingBusinessDate?: Date// [10] 715 (LocalDate)
  MarketID?: string// [11] 1301 (String)
  MarketSegmentID?: string// [12] 1300 (String)
  SecurityListID?: string// [13] 1465 (String)
  SecurityListRefID?: string// [14] 1466 (String)
  SecurityListDesc?: string// [15] 1467 (String)
  EncodedSecurityListDescLen?: number// [16] 1468 (Length)
  EncodedSecurityListDesc?: Buffer// [17] 1469 (RawData)
  SecurityListType?: number// [18] 1470 (Int)
  SecurityListTypeSource?: number// [19] 1471 (Int)
  TransactTime?: Date// [20] 60 (UtcTimestamp)
  StandardTrailer: IStandardTrailer// [21] SignatureLength.93, Signature.89, CheckSum.10
}
