import { IStandardHeader } from './set/standard_header'
import { ISecLstUpdRelSymGrp } from './set/sec_lst_upd_rel_sym_grp'
import { IStandardTrailer } from './set/standard_trailer'

export interface ISecurityListUpdateReport {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  SecurityReportID?: number// [2] 964 (Int)
  SecurityReqID?: string// [3] 320 (String)
  SecurityResponseID?: string// [4] 322 (String)
  SecurityRequestResult?: number// [5] 560 (Int)
  TotNoRelatedSym?: number// [6] 393 (Int)
  ClearingBusinessDate?: Date// [7] 715 (LocalDate)
  SecurityUpdateAction?: string// [8] 980 (String)
  CorporateAction?: string// [9] 292 (String)
  LastFragment?: boolean// [10] 893 (Boolean)
  SecLstUpdRelSymGrp?: ISecLstUpdRelSymGrp// [11] NoRelatedSym.146, Symbol.55 .. StipulationValue.234
  StandardTrailer: IStandardTrailer// [12] SignatureLength.93, Signature.89, CheckSum.10
}
