import { ISecAltIDGrp } from './sec_alt_id_grp'
import { IEvntGrp } from './evnt_grp'
import { IInstrumentParties } from './instrument_parties'

export interface IInstrument {
  Symbol?: string// [1] 55 (String)
  SymbolSfx?: string// [2] 65 (String)
  SecurityID?: string// [3] 48 (String)
  SecurityIDSource?: string// [4] 22 (String)
  SecAltIDGrp?: ISecAltIDGrp// [5] NoSecurityAltID.454, SecurityAltID.455, SecurityAltIDSource.456
  Product?: number// [6] 460 (Int)
  SecurityGroup?: string// [7] 1151 (String)
  CFICode?: string// [8] 461 (String)
  SecurityType?: string// [9] 167 (String)
  SecuritySubType?: string// [10] 762 (String)
  MaturityMonthYear?: string// [11] 200 (String)
  MaturityDate?: Date// [12] 541 (LocalDate)
  CouponPaymentDate?: Date// [13] 224 (LocalDate)
  IssueDate?: Date// [14] 225 (LocalDate)
  RepoCollateralSecurityType?: number// [15] 239 (Int)
  RepurchaseTerm?: number// [16] 226 (Int)
  RepurchaseRate?: number// [17] 227 (Float)
  Factor?: number// [18] 228 (Float)
  CreditRating?: string// [19] 255 (String)
  InstrRegistry?: string// [20] 543 (String)
  CountryOfIssue?: string// [21] 470 (String)
  StateOrProvinceOfIssue?: string// [22] 471 (String)
  LocaleOfIssue?: string// [23] 472 (String)
  RedemptionDate?: Date// [24] 240 (LocalDate)
  StrikePrice?: number// [25] 202 (Float)
  StrikeCurrency?: string// [26] 947 (String)
  TickSize?: number// [27] 5023 (Float)
  PriceLowLimit?: number// [28] 5025 (Float)
  PriceHighLimit?: number// [29] 5024 (Float)
  SizeLowLimit?: number// [30] 7115 (Float)
  SizeHighLimit?: number// [31] 7116 (Float)
  MaxAmount?: number// [32] 5516 (Float)
  QuoteSizeLowLimit?: number// [33] 7119 (Float)
  QuoteSizeHighLimit?: number// [34] 7120 (Float)
  InstrumentPricePrecision?: number// [35] 5514 (Int)
  InstrumentSizePrecision?: number// [36] 7117 (Int)
  OptAttribute?: string// [37] 206 (String)
  ContractMultiplier?: number// [38] 231 (Float)
  CouponRate?: number// [39] 223 (Float)
  SecurityExchange?: string// [40] 207 (String)
  Issuer?: string// [41] 106 (String)
  EncodedIssuerLen?: number// [42] 348 (Length)
  EncodedIssuer?: Buffer// [43] 349 (RawData)
  SecurityDesc?: string// [44] 107 (String)
  EncodedSecurityDescLen?: number// [45] 350 (Length)
  EncodedSecurityDesc?: Buffer// [46] 351 (RawData)
  Pool?: string// [47] 691 (String)
  ContractSettlMonth?: string// [48] 667 (String)
  CPProgram?: number// [49] 875 (Int)
  CPRegType?: string// [50] 876 (String)
  EvntGrp?: IEvntGrp// [51] NoEvents.864, EventType.865 .. EventText.868
  DatedDate?: Date// [52] 873 (LocalDate)
  InterestAccrualDate?: Date// [53] 874 (LocalDate)
  SecurityStatus?: string// [54] 965 (String)
  SettleOnOpenFlag?: string// [55] 966 (String)
  InstrmtAssignmentMethod?: string// [56] 1049 (String)
  StrikeMultiplier?: number// [57] 967 (Float)
  StrikeValue?: number// [58] 968 (Float)
  MinPriceIncrement?: number// [59] 969 (Float)
  PositionLimit?: number// [60] 970 (Int)
  NTPositionLimit?: number// [61] 971 (Int)
  InstrumentParties?: IInstrumentParties// [62] NoInstrumentParties.1018, InstrumentPartyID.1019 .. InstrumentPartySubIDType.1054
  UnitofMeasure?: string// [63] 996 (String)
  TimeUnit?: string// [64] 997 (String)
  MaturityTime?: string// [65] 1079 (String)
  RofexProps?: string// [66] 7200 (String)
  TradingDeadline?: number// [67] 5517 (Int)
}
