import { IInstrument } from './instrument'
import { IInstrumentExtension } from './instrument_extension'
import { IFinancingDetails } from './financing_details'
import { ISecLstUpdRelSymsLegGrp } from './sec_lst_upd_rel_syms_leg_grp'
import { ISpreadOrBenchmarkCurveData } from './spread_or_benchmark_curve_data'
import { IYieldData } from './yield_data'
import { IUnderlyingInstrument } from './underlying_instrument'
import { IStipulations } from './stipulations'

export interface ISecLstUpdRelSymGrpNoRelatedSym {
  Instrument?: IInstrument// [1] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  InstrumentExtension?: IInstrumentExtension// [2] DeliveryForm.668, PctAtRisk.869 .. InstrAttribValue.872
  FinancingDetails?: IFinancingDetails// [3] AgreementDesc.913, AgreementID.914 .. MarginRatio.898
  SecLstUpdRelSymsLegGrp?: ISecLstUpdRelSymsLegGrp// [4] NoLegs.555, LegSymbol.600 .. LegBenchmarkPriceType.680
  SpreadOrBenchmarkCurveData?: ISpreadOrBenchmarkCurveData// [5] Spread.218, BenchmarkCurveCurrency.220 .. BenchmarkSecurityIDSource.761
  YieldData?: IYieldData// [6] YieldType.235, Yield.236 .. YieldRedemptionPriceType.698
  RoundLot?: number// [7] 561 (Float)
  MinTradeVol?: number// [8] 562 (Float)
  TradingSessionID?: string// [9] 336 (String)
  TradingSessionSubID?: string// [10] 625 (String)
  ExpirationCycle?: number// [11] 827 (Int)
  Text?: string// [12] 58 (String)
  EncodedTextLen?: number// [13] 354 (Length)
  EncodedText?: Buffer// [14] 355 (RawData)
  UnderlyingInstrument?: IUnderlyingInstrument// [15] UnderlyingSymbol.311, UnderlyingSymbolSfx.312 .. UnderlyingFXRateCalc.1046
  Currency?: string// [16] 15 (String)
  Stipulations?: IStipulations// [17] NoStipulations.232, StipulationType.233, StipulationValue.234
}
