import { IParties } from './parties'
import { IClrInstGrp } from './clr_inst_grp'
import { ICommissionData } from './commission_data'
import { IContAmtGrp } from './cont_amt_grp'
import { IStipulations } from './stipulations'
import { IMiscFeesGrp } from './misc_fees_grp'
import { ITrdAllocGrp } from './trd_alloc_grp'
import { ISideTrdRegTS } from './side_trd_reg_ts'

export interface ITrdCapRptSideGrpNoSides {
  Side: string// [1] 54 (String)
  OrderID?: string// [2] 37 (String)
  SecondaryOrderID?: string// [3] 198 (String)
  ClOrdID?: string// [4] 11 (String)
  SecondaryClOrdID?: string// [5] 526 (String)
  ListID?: string// [6] 66 (String)
  Parties: IParties// [7] NoPartyIDs.453, PartyID.448 .. PartySubIDType.803
  Account?: string// [8] 1 (String)
  AcctIDSource?: number// [9] 660 (Int)
  AccountType?: number// [10] 581 (Int)
  ProcessCode?: string// [11] 81 (String)
  OddLot?: boolean// [12] 575 (Boolean)
  ClrInstGrp: IClrInstGrp// [13] NoClearingInstructions.576, ClearingInstruction.577
  TradeInputSource?: string// [14] 578 (String)
  TradeInputDevice?: string// [15] 579 (String)
  OrderInputDevice?: string// [16] 821 (String)
  Currency?: string// [17] 15 (String)
  ComplianceID?: string// [18] 376 (String)
  SolicitedFlag?: boolean// [19] 377 (Boolean)
  OrderCapacity?: string// [20] 528 (String)
  OrderRestrictions?: string// [21] 529 (String)
  CustOrderCapacity?: number// [22] 582 (Int)
  OrdType?: string// [23] 40 (String)
  ExecInst?: string// [24] 18 (String)
  TransBkdTime?: Date// [25] 483 (UtcTimestamp)
  TradingSessionID?: string// [26] 336 (String)
  TradingSessionSubID?: string// [27] 625 (String)
  TimeBracket?: string// [28] 943 (String)
  CommissionData: ICommissionData// [29] Commission.12, CommType.13 .. FundRenewWaiv.497
  NumDaysInterest?: number// [30] 157 (Int)
  ExDate?: Date// [31] 230 (LocalDate)
  AccruedInterestRate?: number// [32] 158 (Float)
  AccruedInterestAmt?: number// [33] 159 (Float)
  InterestAtMaturity?: number// [34] 738 (Float)
  EndAccruedInterestAmt?: number// [35] 920 (Float)
  StartCash?: number// [36] 921 (Float)
  EndCash?: number// [37] 922 (Float)
  Concession?: number// [38] 238 (Float)
  TotalTakedown?: number// [39] 237 (Float)
  NetMoney?: number// [40] 118 (Float)
  SettlCurrAmt?: number// [41] 119 (Float)
  SettlCurrency?: string// [42] 120 (String)
  SettlCurrFxRate?: number// [43] 155 (Float)
  SettlCurrFxRateCalc?: string// [44] 156 (String)
  PositionEffect?: string// [45] 77 (String)
  Text?: string// [46] 58 (String)
  EncodedTextLen?: number// [47] 354 (Length)
  EncodedText?: Buffer// [48] 355 (RawData)
  SideMultiLegReportingType?: number// [49] 752 (Int)
  ContAmtGrp: IContAmtGrp// [50] NoContAmts.518, ContAmtType.519 .. ContAmtCurr.521
  Stipulations: IStipulations// [51] NoStipulations.232, StipulationType.233, StipulationValue.234
  MiscFeesGrp: IMiscFeesGrp// [52] NoMiscFees.136, MiscFeeAmt.137 .. MiscFeeBasis.891
  ExchangeRule?: string// [53] 825 (String)
  TradeAllocIndicator?: number// [54] 826 (Int)
  PreallocMethod?: string// [55] 591 (String)
  AllocID?: string// [56] 70 (String)
  TrdAllocGrp: ITrdAllocGrp// [57] NoAllocs.78, AllocAccount.79 .. AllocClearingFeeIndicator.1136
  SideQty?: number// [58] 1009 (Int)
  SideTradeReportID?: string// [59] 1005 (String)
  SideFillStationCd?: string// [60] 1006 (String)
  SideReasonCd?: string// [61] 1007 (String)
  RptSeq?: number// [62] 83 (Int)
  SideTrdSubTyp?: number// [63] 1008 (Int)
  SideTrdRegTS: ISideTrdRegTS// [64] NoSideTrdRegTS.1016, SideTrdRegTimestamp.1012 .. SideTrdRegTimestampSrc.1014
  ExecRefID?: string// [65] 19 (String)
  LotType?: string// [66] 1093 (String)
  SideGrossTradeAmt?: number// [67] 1072 (Float)
  AggressorIndicator?: boolean// [68] 1057 (Boolean)
  ExchangeSpecialInstructions?: string// [69] 1139 (String)
}
