import { IUndSecAltIDGrp } from './und_sec_alt_id_grp'
import { IUnderlyingStipulations } from './underlying_stipulations'
import { IUndlyInstrumentParties } from './undly_instrument_parties'

export interface IUnderlyingInstrument {
  UnderlyingSymbol?: string// [1] 311 (String)
  UnderlyingSymbolSfx?: string// [2] 312 (String)
  UnderlyingSecurityID?: string// [3] 309 (String)
  UnderlyingSecurityIDSource?: string// [4] 305 (String)
  UndSecAltIDGrp?: IUndSecAltIDGrp// [5] NoUnderlyingSecurityAltID.457, UnderlyingSecurityAltID.458, UnderlyingSecurityAltIDSource.459
  UnderlyingProduct?: number// [6] 462 (Int)
  UnderlyingCFICode?: string// [7] 463 (String)
  UnderlyingSecurityType?: string// [8] 310 (String)
  UnderlyingSecuritySubType?: string// [9] 763 (String)
  UnderlyingMaturityMonthYear?: string// [10] 313 (String)
  UnderlyingMaturityDate?: Date// [11] 542 (LocalDate)
  UnderlyingCouponPaymentDate?: Date// [12] 241 (LocalDate)
  UnderlyingIssueDate?: Date// [13] 242 (LocalDate)
  UnderlyingRepoCollateralSecurityType?: number// [14] 243 (Int)
  UnderlyingRepurchaseTerm?: number// [15] 244 (Int)
  UnderlyingRepurchaseRate?: number// [16] 245 (Float)
  UnderlyingFactor?: number// [17] 246 (Float)
  UnderlyingCreditRating?: string// [18] 256 (String)
  UnderlyingInstrRegistry?: string// [19] 595 (String)
  UnderlyingCountryOfIssue?: string// [20] 592 (String)
  UnderlyingStateOrProvinceOfIssue?: string// [21] 593 (String)
  UnderlyingLocaleOfIssue?: string// [22] 594 (String)
  UnderlyingRedemptionDate?: Date// [23] 247 (LocalDate)
  UnderlyingStrikePrice?: number// [24] 316 (Float)
  UnderlyingStrikeCurrency?: string// [25] 941 (String)
  UnderlyingOptAttribute?: string// [26] 317 (String)
  UnderlyingContractMultiplier?: number// [27] 436 (Float)
  UnderlyingCouponRate?: number// [28] 435 (Float)
  UnderlyingSecurityExchange?: string// [29] 308 (String)
  UnderlyingIssuer?: string// [30] 306 (String)
  EncodedUnderlyingIssuerLen?: number// [31] 362 (Length)
  EncodedUnderlyingIssuer?: Buffer// [32] 363 (RawData)
  UnderlyingSecurityDesc?: string// [33] 307 (String)
  EncodedUnderlyingSecurityDescLen?: number// [34] 364 (Length)
  EncodedUnderlyingSecurityDesc?: Buffer// [35] 365 (RawData)
  UnderlyingCPProgram?: string// [36] 877 (String)
  UnderlyingCPRegType?: string// [37] 878 (String)
  UnderlyingCurrency?: string// [38] 318 (String)
  UnderlyingQty?: number// [39] 879 (Float)
  UnderlyingPx?: number// [40] 810 (Float)
  UnderlyingDirtyPrice?: number// [41] 882 (Float)
  UnderlyingEndPrice?: number// [42] 883 (Float)
  UnderlyingStartValue?: number// [43] 884 (Float)
  UnderlyingCurrentValue?: number// [44] 885 (Float)
  UnderlyingEndValue?: number// [45] 886 (Float)
  UnderlyingStipulations?: IUnderlyingStipulations// [46] NoUnderlyingStips.887, UnderlyingStipType.888, UnderlyingStipValue.889
  UnderlyingAllocationPercent?: number// [47] 972 (Float)
  UnderlyingSettlementType?: number// [48] 975 (Int)
  UnderlyingCashAmount?: number// [49] 973 (Float)
  UnderlyingCashType?: string// [50] 974 (String)
  UnderlyingUnitofMeasure?: string// [51] 998 (String)
  UnderlyingTimeUnit?: string// [52] 1000 (String)
  UnderlyingCapValue?: number// [53] 1038 (Float)
  UndlyInstrumentParties?: IUndlyInstrumentParties// [54] NoUndlyInstrumentParties.1058, UndlyInstrumentPartyID.1059 .. UndlyInstrumentPartySubIDType.1064
  UnderlyingSettlMethod?: string// [55] 1039 (String)
  UnderlyingAdjustedQuantity?: number// [56] 1044 (Float)
  UnderlyingFXRate?: number// [57] 1045 (Float)
  UnderlyingFXRateCalc?: string// [58] 1046 (String)
}
