import { IStandardHeader } from './set/standard_header'
import { IInstrument } from './set/instrument'
import { IStandardTrailer } from './set/standard_trailer'

export interface ITradingSessionStatus {
  StandardHeader: IStandardHeader// [1] BeginString.8, BodyLength.9 .. CstmApplVerID.1129
  TradSesReqID?: string// [2] 335 (String)
  MarketID?: string// [3] 1301 (String)
  MarketSegmentID?: string// [4] 1300 (String)
  TradingSessionID: string// [5] 336 (String)
  TradingSessionSubID?: string// [6] 625 (String)
  TradSesMethod?: number// [7] 338 (Int)
  TradSesMode?: number// [8] 339 (Int)
  UnsolicitedIndicator?: boolean// [9] 325 (Boolean)
  TradSesStatus: number// [10] 340 (Int)
  TradSesStatusRejReason?: number// [11] 567 (Int)
  TradSesStartTime?: Date// [12] 341 (UtcTimestamp)
  TradSesOpenTime?: Date// [13] 342 (UtcTimestamp)
  TradSesPreCloseTime?: Date// [14] 343 (UtcTimestamp)
  TradSesCloseTime?: Date// [15] 344 (UtcTimestamp)
  TradSesEndTime?: Date// [16] 345 (UtcTimestamp)
  TotalVolumeTraded?: number// [17] 387 (Float)
  Text?: string// [18] 58 (String)
  EncodedTextLen?: number// [19] 354 (Length)
  EncodedText?: Buffer// [20] 355 (RawData)
  Instrument?: IInstrument// [21] Symbol.55, SymbolSfx.65 .. TradingDeadline.5517
  StandardTrailer: IStandardTrailer// [22] SignatureLength.93, Signature.89, CheckSum.10
}
